unit GMMap;

interface
     uses OpenGl,Windows,GMVars,GMUtilite,Textures,log,IDX_sound;



const
	BrickFlags: ARRAY[1..20] OF BYTE =
	(48,4+8+32+128,49,8+32,50,4+8+32,51,4+8+32,52,2,53,4,54,4+8,55,2,56,2,65,4+8+16+32);

const
      BlockSize=32;
      BlockSizeDiv=(BlockSize div 2);

Type
    TPlayerPos = record
		x,y: BYTE;
		xoffs,yoffs: SHORTINT;
    end;

type
   TPlayer = record
		Command: BYTE;
		NewCommandWas: BOOLEAN;
		NewCommand: BYTE;
		Position: TPlayerPos;
		Sprite,SubSprite: BYTE;
		SpriteData: BYTE;
		Controller: BYTE;
		Prizes: BYTE;
		Colour: BYTE;
                spriteTime:Byte;
	END;

	TBrick = RECORD
		Image: BYTE;
		Count: BYTE;
		Flags: BYTE;
		IdleCount: BYTE;
	END;



type
   Tmap=object
     MapW : Integer;
     MapH : Integer;

   Level:integer;
   Lives: Integer;
   Score: LongInt;

   TotalPrizes:Integer;
   GameResult: Integer;
   ComputerTurn: WORD;
   ComputerReaction: WORD;

   ShowLives: Boolean;
   ShowScore: Boolean;
   ShowLevel: Boolean;
   EndOfGame: Boolean;
   Paused: Boolean;
   GameStarted: Boolean;

   Field: array[1..30,1..16] OF TBrick;
   Players: array[1..20] OF TPlayer;
   HumanAnim:array[1..9,1..2] of Byte;

  Texture:array[0..10] of cardinal;
  BackTexture:array[0..1] of Cardinal;
  PlayerPic:array[0..1] of Cardinal;
  StatusPic:array[0..2] of Cardinal;

  procedure Init;
  procedure Load(Number: BYTE);
  procedure Close;
  procedure Draw;
  procedure RefreshLevel;

  procedure UpdateLevel;
  procedure UpdateBricks;
  Procedure UpdatePlayers;
  Procedure ComputerPlayer;
  end;


var
 Mymap:Tmap;
 SelectMenu:integer;

Procedure ProccesGame;
Procedure Render;
Procedure InitGame;
Procedure CloseGame;
implementation
        uses GMWindow;

Procedure Tmap.UpdateLevel;
begin

 if EndOfGame then
  begin
   if Keys[32] then
     begin

       IF GameResult=10 THEN
       BEGIN

	 INC(Lives);
	 Score:=Score+100*Level;
         INC(Level);
         if Level>144 then Level:=1;

         RefreshLevel;
       END
       ELSE
       BEGIN
         if Lives>0 then
         begin
	  DEC(Lives);
          RefreshLevel;
         end
         else
         begin
         GameStatus:=sGMenu;
         Paused:=false;

         end;
       end;

       Keys[32]:=False;
     end
   else
   Exit;
end;

 if Keys[VK_ESCAPE] then
 begin
  Paused:=true;
  GameStatus:=sGMenu;
  Keys[VK_ESCAPE]:=false;
  exit;
 end;

 if Keys[vk_F1] then
 begin
    INC(Level);
    if Level>144 then Level:=1;
    RefreshLevel;
    Keys[vk_F1]:=false;
    exit;
 end;

 if Keys[vk_F2] then
 begin
    dec(Level);
    if Level<1 then Level:=144;
    RefreshLevel;
    Keys[vk_F2]:=false;
    exit;
 end;

 if Keys[80] then
 begin

  if GameStarted=false then
  begin
   GameStarted:=True;
   Paused:=False;
  end
  else
  Paused:=not Paused;

  Keys[80]:=False;
 end;

 if Keys[90] then  //Z
 begin
  if GameStarted=false then
  begin
   GameStarted:=True;
  end
  else
  begin
   Players[1].NewCommand:=6;
   Players[1].NewCommandWas:=TRUE;
   PlaySoundFromMEM(0);
  end;

  Keys[90]:=False;
 end;

 if Keys[88] then //X
 begin
  if GameStarted=false then
  begin
   GameStarted:=True;
  end
  else
  begin
   Players[1].NewCommand:=7;
   Players[1].NewCommandWas:=TRUE;
   PlaySoundFromMEM(0);
  end;
  Keys[88]:=False;
 end;

 if Keys[VK_Left] then
 begin
  GameStarted:=True;
  Players[1].NewCommand:=1;
  Players[1].NewCommandWas:=TRUE;
  Keys[VK_Left]:=False;
 end;

 if Keys[VK_Right] then
 begin
  GameStarted:=True;
  Players[1].NewCommand:=2;
  Players[1].NewCommandWas:=TRUE;
  Keys[VK_Right]:=False;
 end;

 if Keys[VK_Up] then
 begin
  GameStarted:=True;
  Players[1].NewCommand:=3;
  Players[1].NewCommandWas:=TRUE;
  Keys[VK_Up]:=False;
 end;

 if Keys[VK_Down] then
 begin
  GameStarted:=True;
  Players[1].NewCommand:=4;
  Players[1].NewCommandWas:=TRUE;
  Keys[VK_Down]:=False;
 end;

 IF (GameStarted) AND (NOT Paused) THEN
 BEGIN
  ComputerPlayer;
  UpdatePlayers;
  UpdateBricks;
 end;



end;

Procedure Tmap.ComputerPlayer;
Var
   k,l,m,f1,f2,i,j: INTEGER;
BEGIN
	IF ComputerTurn>=ComputerReaction THEN
        BEGIN
		ComputerTurn:=0;

		FOR k:=1 TO 10 DO
                BEGIN
			WITH Players[k] DO
                        BEGIN
				IF Controller=2 THEN
                                BEGIN
					NewCommandWas:=TRUE;
					NewCommand:=10;

					IF (Position.y>Players[1].Position.y) THEN
                                        BEGIN
						IF ((Field[Position.x,Position.y].Image=2) AND
						   (Field[Position.x,Position.y].Flags AND 16=0) AND
						  ((Field[Position.x,Position.y-1].Image=2) OR
						   (Field[Position.x,Position.y-1].Flags AND 4<>0)) AND
						   (Position.y>1)) THEN
                                                BEGIN
							NewCommand:=3;
						END
						ELSE
						BEGIN
							m:=1;
							l:=Position.x;
							i:=1;

							WHILE i<>0 DO
                                                        BEGIN
								l:=l+i;
								IF ((Field[l,Position.y].Image=2) AND
								    (Field[l,Position.y].Flags AND 16=0)) AND
								   ((Field[l,Position.y-1].Image=2) AND
								    (Field[l,Position.y-1].Flags AND 16=0)) AND
								    (Position.y<>1) THEN
                                                                BEGIN
									IF m=0 THEN
                                                                        BEGIN
										f2:=Position.x-l;
										BREAK;
									END;

									m:=0;
									i:=NOT i+1;
									f1:=l-Position.x;
									l:=Position.x;
								END
								ELSE
								IF (Field[l,Position.y].Flags AND 8=0) OR
                                                                   (l>30) OR
                                                                   (l<1) THEN
                                                                BEGIN
									IF m=0 THEN
                                                                        BEGIN
									  f2:=100;
									  BREAK;
									END;

									m:=0;
									i:=NOT i+1;
									l:=Position.x;
									f1:=100;
								END;
							END;


							IF (f1=100) AND (f2=100) THEN
								NewCommand:=10
							ELSE
							BEGIN
								IF f1>f2 THEN
									NewCommand:=1
								ELSE
									NewCommand:=2;
							END;
						END;
					END
					ELSE
					IF (Position.y<Players[1].Position.y) THEN
                                        BEGIN
						IF (((Field[Position.x,Position.y+1].Image=2) AND
						     (Field[Position.x,Position.y+1].Flags AND 16=0)) OR
						     (Field[Position.x,Position.y+1].Flags AND 4<>0)) AND
						     (Position.y<16) AND
                                                     (Field[Position.x,Position.y+1].Flags AND 1=0) THEN
                                                BEGIN
							NewCommand:=4;
						END
						ELSE
						BEGIN
							m:=1;
							l:=Position.x;
							i:=1;
							WHILE i<>0 DO
                                                        BEGIN
								l:=l+i;
								IF ((Field[l,Position.y+1].Image=2) AND
							            (Field[l,Position.y+1].Flags AND 16=0)) OR
								   ((Field[l,Position.y+1].Flags AND 4<>0) AND
								    (Field[l,Position.y+1].Flags AND 1=0)) THEN
                                                                BEGIN
									IF m=0 THEN
                                                                        BEGIN
										f2:=Position.x-l;
										BREAK;
									END;

									m:=0;
									i:=NOT i+1;
									f1:=l-Position.x;
									l:=Position.x;
								END
								ELSE
								IF (Field[l,Position.y].Flags AND 8=0) OR
                                                                   (l>30) OR
                                                                   (l<1) THEN
                                                                BEGIN
									IF m=0 THEN
                                                                        BEGIN
										f2:=100;
										BREAK;
									END;

									m:=0;
									i:=NOT i+1;
									l:=Position.x;
									f1:=100;

								END;
							END;
							IF (f1=100) AND (f2=100) THEN
								NewCommand:=10
							ELSE
							BEGIN
								IF f1>f2 THEN
									NewCommand:=1
								ELSE
									NewCommand:=2;
							END;
						END;
					END
					ELSE
					BEGIN
						IF (Position.x>Players[1].Position.x) THEN
							NewCommand:=1;
						IF (Position.x<Players[1].Position.x) THEN
							NewCommand:=2;
					END;
				END;
			END;
		END;
	END
	ELSE
	  INC(ComputerTurn);
END;



Procedure Tmap.UpdatePlayers;
Var
	i,j,k,m: INTEGER;
	spd: WORD;
BEGIN
	FOR i:=1 TO 10 DO
        BEGIN
		WITH Players[i] DO
                BEGIN
			IF Controller<>0 THEN
                        BEGIN
				IF (Field[Position.x,Position.y].Flags AND 2<>0) THEN
                                BEGIN
					IF i=1 THEN
                                        BEGIN
						EndOfGame:=TRUE;
						GameResult:=1;
                                                PlaySoundFromMEM(2);
						EXIT;
					END;

					IF Prizes<>0 THEN
                                        BEGIN
						Prizes:=0;
						Field[Position.x,Position.y-1].Image:=4;
						Field[Position.x,Position.y-1].Flags:=BrickFlags[8];
					END;
					REPEAT
						Position.y:=RANDOM(2)+1;
						Position.x:=RANDOM(30)+1;
					UNTIL (Field[Position.x,Position.y].Image=1) OR
					      (Field[Position.x,Position.y].Image=2) OR
					      (Field[Position.x,Position.y].Image=3) OR
					      (Field[Position.x,Position.y].Image=4);

					       Command:=10;
					       CONTINUE;
				END;

				IF (Field[Position.x,Position.y].Image=4) THEN
                                BEGIN
				IF (Controller=2) THEN
                                        BEGIN
						IF Prizes=0 THEN
                                                BEGIN
							INC(Prizes);
							Field[Position.x,Position.y].Image:=1;
							Field[Position.x,Position.y].Flags:=BrickFlags[2];
						END;
					END
					ELSE
					BEGIN
                                        PlaySoundFromMEM(1);
						DEC(TotalPrizes);
						Score:=Score+10;
						Field[Position.x,Position.y].Image:=1;
						Field[Position.x,Position.y].Flags:=BrickFlags[2];
					END;
				END;


				IF (i=1) THEN
                                BEGIN
                                      IF (TotalPrizes=0) AND (Position.y=1) AND (Field[Position.x,Position.y].Image=2) THEN
                                    BEGIN
                                            EndOfGame:=TRUE;
                                            GameResult:=10;
                                            PlaySoundFromMEM(3);
                                            EXIT;
                                    END;
                                    FOR k:=2 TO 10 DO
                                    IF (Players[k].Controller<>0) THEN
                                    IF (Players[k].Position.x=Position.x) AND (Players[k].Position.y=Position.y) THEN
                                    BEGIN
                                            EndOfGame:=TRUE;
                                            GameResult:=2;
                                            PlaySoundFromMEM(2);
                                            EXIT;
                                    END;
				END;
				IF (Field[Position.x,Position.y].Flags AND 1<>0) THEN
                                BEGIN
					IF (Controller=2) THEN
                                        BEGIN
						IF Prizes<>0 THEN
                                                BEGIN
							Prizes:=0;
							Field[Position.x,Position.y-1].Image:=4;
							Field[Position.x,Position.y-1].Flags:=BrickFlags[8];
						END;
					END;
				END;

				IF Controller=2 THEN
					spd:=2
				ELSE
					spd:=3;

                                //
				IF (Field[Position.x,Position.y+1].Flags AND 4<>0) AND
                                   (Field[Position.x,Position.y].Image<>3) AND
                                   ((Field[Position.x,Position.y].Image<>2) OR
                                   (Field[Position.x,Position.y].Flags AND 16<>0)) AND
                                   (Position.y<16) THEN
                                BEGIN
                                       m:=0;
					FOR k:=2 TO 10 DO
						IF (k<>i) AND (Players[k].Controller<>0) THEN
							IF (Players[k].Position.x=Position.x) AND
							   (Players[k].Position.y=Position.y+1) AND
							   (Position.y<16) THEN
                                                        BEGIN
								m:=100;
								BREAK;
							END;

                                        if m=100 then k:=m;

					IF k<>100 THEN
                                        BEGIN
						NewCommand:=5;
						NewCommandWas:=TRUE;
					END;
				END;
				IF NewCommandWas THEN
                                BEGIN
					IF (NewCommand<>Command) AND (Command<>5) THEN
                                        BEGIN
						Command:=NewCommand;
						Sprite:=1;
					END;

					NewCommandWas:=FALSE;
				END;
				IF (Command=1) THEN
                                BEGIN
					IF (Field[Position.x,Position.y].Image=3) THEN
                                        BEGIN
						IF Position.xoffs<1 THEN
                                                BEGIN
							IF ((Field[Position.x-1,Position.y].Flags AND 8=0) AND
							    (Field[Position.x-1,Position.y].Image<>3)) OR
							    (Field[Position.x,Position.y].Image<>3) OR
                                                            (Position.x=1) THEN
                                                        BEGIN
								Command:=10;
								Position.xoffs:=0;
							END;
						END;

						IF (Command<>10) AND (SpriteData<>6) THEN
                                                BEGIN
							SpriteData:=6;
							Sprite:=1;
						END;
					END
					ELSE
					BEGIN
						IF Position.xoffs<1 THEN
                                                BEGIN
							IF (Field[Position.x-1,Position.y].Flags AND 8=0) OR
                                                           (Position.x=1) THEN
                                                        BEGIN
								Command:=10;
								Position.xoffs:=0;
							END;
						END;

						IF (Command<>10) AND (SpriteData<>1) THEN SpriteData:=1;

					END;

					IF Command<>10 THEN
                                        BEGIN
						k:=1;
						WHILE (k>0) DO
                                                BEGIN
							INC(k);

							IF k=11 THEN
                                                        BEGIN
                                                            IF (SpriteData=6) THEN
                                                            BEGIN
                                                                    IF (Sprite=2) THEN DEC(Position.xoffs,5);
                                                                    IF (Sprite=3) THEN DEC(Position.xoffs,1);
                                                            END
                                                            ELSE
                                                                    DEC(Position.xoffs,spd);

							    BREAK;
							END;

							IF (k<>i) AND
                                                           (i<>1) AND
                                                           (Players[k].Controller<>0) THEN
                                                        IF (Players[k].Position.x=Position.x-1) AND
							   (Players[k].Position.y=Position.y) THEN
                                                        BEGIN
                                                                Command:=10;
                                                                BREAK;
                                                        END;
						END;
					END;
				END;
				IF (Command=2) THEN
                                BEGIN
					IF (Field[Position.x,Position.y].Image=3) THEN
                                        BEGIN
						IF Position.xoffs>-1 THEN
                                                BEGIN
							IF ((Field[Position.x+1,Position.y].Flags AND 8=0) AND
							    (Field[Position.x+1,Position.y].Image<>3)) OR
                                                            (Field[Position.x,Position.y].Image<>3) OR (Position.x=30) THEN
                                                        BEGIN
								Command:=10;
								Position.xoffs:=0;
							END;
						END;

						IF (Command<>10) AND (SpriteData<>7) THEN
                                                BEGIN
							SpriteData:=7;
							Sprite:=1;
						END;
					END
					ELSE
					BEGIN
						IF Position.xoffs>-1 THEN
                                                BEGIN
							IF (Field[Position.x+1,Position.y].Flags AND 8=0) OR (Position.x=30) THEN
                                                        BEGIN
								Command:=10;
								Position.xoffs:=0;
							END;
						END;

						IF (Command<>10) AND (SpriteData<>2) THEN SpriteData:=2;
					END;
					IF Command<>10 THEN
                                        BEGIN
						k:=1;
						WHILE (k>0) DO
                                                BEGIN

                                                    INC(k);

                                                    IF k=11 THEN
                                                    BEGIN
                                                      IF (SpriteData=7) THEN
                                                      BEGIN
                                                         IF (Sprite=2) THEN INC(Position.xoffs,5);
                                                         IF (Sprite=3) THEN INC(Position.xoffs,1);
                                                      END
                                                      ELSE
                                                         INC(Position.xoffs,spd);
                                                       BREAK;
                                                    END;

                                                    IF (k<>i) AND
                                                       (i<>1) AND
                                                       (Players[k].Controller<>0) THEN
                                                    IF (Players[k].Position.x=Position.x+1) AND
                                                       (Players[k].Position.y=Position.y) THEN
                                                    BEGIN
                                                        Command:=10;
                                                        BREAK;
                                                    END;
						END;
					END;
				END;
				IF (Command=3) THEN
                                BEGIN
					IF Position.yoffs<1 THEN
                                        BEGIN
						IF ((Field[Position.x,Position.y].Image<>2) OR
						    (Field[Position.x,Position.y].Flags AND 16<>0)) OR
						   ((Field[Position.x,Position.y-1].Flags AND 4=0) AND
						   ((Field[Position.x,Position.y-1].Image<>2) OR
						    (Field[Position.x,Position.y-1].Flags AND 16<>0))) OR
						    (Position.y<2) THEN
                                                BEGIN
							Command:=10;
							Position.yoffs:=0;
						END;
					END;
					IF (Command<>10) AND (SpriteData<>3) THEN SpriteData:=3;
					IF Command<>10 THEN
                                        BEGIN
						k:=1;
						WHILE (k>0) DO
                                                BEGIN
							INC(k);
							IF k=11 THEN
                                                        BEGIN
                                                            DEC(Position.yoffs,spd);
                                                            BREAK;
							END;

							IF (k<>i) AND
                                                           (i<>1) AND
                                                           (Players[k].Controller<>0) THEN
							IF (Players[k].Position.y=Position.y-1) AND
							   (Players[k].Position.x=Position.x) THEN
                                                        BEGIN
                                                            Command:=10;
                                                            BREAK;
							END;
						END;
					END;
				END;
				IF (Command=4) THEN
                                BEGIN

					IF (Field[Position.x,Position.y].Image=3) AND
					  ((Field[Position.x,Position.y+1].Image<>2) OR
                                           (Field[Position.x,Position.y+1].Flags AND 16<>0)) AND
					   (Position.y<16) THEN
                                        BEGIN
						Command:=5;
						Sprite:=1;
						IF (Field[Position.x,Position.y+1].Flags AND 4<>0) THEN
							INC(Position.yoffs);
					END
					ELSE
					BEGIN
						IF Position.yoffs>-1 THEN
                                                BEGIN
                                                    IF (((Field[Position.x,Position.y+1].Image<>2) OR
                                                         (Field[Position.x,Position.y+1].Flags AND 16<>0)) AND
                                                         (Field[Position.x,Position.y+1].Flags AND 4=0)) OR
                                                         (Position.y=16) THEN
                                                    BEGIN
                                                            Command:=10;
                                                            Position.yoffs:=0;
                                                    END;
						END;
                  				IF (Command<>10) AND (SpriteData<>4) THEN SpriteData:=4;
						IF Command<>10 THEN
                                                BEGIN
							k:=1;
							WHILE (k>0) DO
                                                        BEGIN
								INC(k);

								IF k=11 THEN
                                                                BEGIN
									INC(Position.yoffs,spd);
									BREAK;
								END;
                         					IF (k<>i) AND
                                                                   (i<>1) AND
                                                                   (Players[k].Controller<>0) THEN
								IF (Players[k].Position.y=Position.y+1) AND
								   (Players[k].Position.x=Position.x) THEN
                                                                BEGIN
                                                                        Command:=10;
                                                                        BREAK;
								END;

							END;
						END;
					END;
				END;
				IF (Command=5) THEN
                                BEGIN

					IF Position.yoffs<1 THEN
                                        BEGIN
						IF (Field[Position.x,Position.y+1].Flags AND 4=0) OR (Position.y=16) OR
						   (Field[Position.x,Position.y].Image=3) OR
						  ((Field[Position.x,Position.y].Flags AND 1<>0) AND (i<>1)) THEN
                                                BEGIN
							Command:=10;

							IF (Field[Position.x,Position.y].Image=3) THEN SpriteData:=5;

							Position.yoffs:=0;
							Position.xoffs:=0;

						END;

						FOR k:=2 TO 10 DO
                                                IF (k<>i) AND
                                                   (Players[k].Controller<>0) THEN
                                                IF (Players[k].Position.x=Position.x) AND
                                                   (Players[k].Position.y=Position.y+1) AND
                                                   (Field[Position.x,Position.y+1].Flags AND 1<>0) AND
                                                   (Position.y<16) THEN
                                                BEGIN
                                                        Command:=10;
                                                        Position.yoffs:=0;
                                                        BREAK;
                                                END;
					END;

					IF (Command<>10) AND (SpriteData<>5) THEN
                                        BEGIN
						SpriteData:=5;
						Sprite:=1;
					END;

					IF Command<>10 THEN
                                        BEGIN
						INC(Position.yoffs,2);
					END;
				END;
				IF (Command=6) THEN
                                BEGIN

					IF (Position.y<16) AND
                                           (Position.x>1) AND
                                           (Field[Position.x-1,Position.y+1].Image=9) AND
					   (Field[Position.x-1,Position.y+1].Flags AND 1=0) AND
					 (((Field[Position.x-1,Position.y].Image=1) OR
					   (Field[Position.x-1,Position.y].Flags AND 1<>0)) OR
					   (Field[Position.x-1,Position.y].Flags AND 16<>0)) THEN
                                        BEGIN

						NewCommandWas:=TRUE;

					      FOR k:=2 TO 10 DO
                                                IF (k<>i) AND
                                                   (Players[k].Controller<>0) THEN
                                                IF (Players[k].Position.x=Position.x-1) AND
                                                   (Players[k].Position.y=Position.y) THEN
                                                BEGIN
                                                  NewCommandWas:=FALSE;
						  BREAK;
						END;

						IF NewCommandWas THEN
                                                BEGIN
							Field[Position.x-1,Position.y+1].Flags:=Field[Position.x-1,Position.y+1].Flags OR 1;
							Position.xoffs:=0;
							SpriteData:=8;
							NewCommandWas:=FALSE;
						END;
					END;
					Command:=10;
				END;
				IF (Command=7) THEN
                                BEGIN

					IF (Position.y<16) AND
                                           (Position.x<30) AND
                                           (Field[Position.x+1,Position.y+1].Image=9) AND
					   (Field[Position.x+1,Position.y+1].Flags AND 1=0) AND
				         (((Field[Position.x+1,Position.y].Image=1) OR
					   (Field[Position.x+1,Position.y].Flags AND 1<>0)) OR
					   (Field[Position.x+1,Position.y].Flags AND 16<>0)) THEN
                                        BEGIN
						NewCommandWas:=TRUE;
                                                
					    FOR k:=2 TO 10 DO
					    	IF (k<>i) AND
                                                   (Players[k].Controller<>0) THEN
					    	IF (Players[k].Position.x=Position.x+1) AND
						   (Players[k].Position.y=Position.y) THEN
                                                BEGIN
					         	NewCommandWas:=FALSE;
						   	BREAK;
					        END;

						IF NewCommandWas THEN
                                                BEGIN
							Field[Position.x+1,Position.y+1].Flags:=Field[Position.x+1,Position.y+1].Flags OR 1;
							Position.xoffs:=0;
							SpriteData:=9;
							NewCommandWas:=FALSE;
						END;
					END;
					Command:=10;

				END;
				IF (Command=1) OR (Command=2) THEN
                                BEGIN
					IF Position.yoffs<0 THEN INC(Position.yoffs)
					ELSE
					IF Position.yoffs>0 THEN DEC(Position.yoffs);
				END;
				IF (Command=3) OR (Command=4) OR (Command=5) THEN
                                BEGIN
					IF Position.xoffs<0 THEN INC(Position.xoffs)
					ELSE
					IF Position.xoffs>0 THEN DEC(Position.xoffs);
				END;
				IF Command<6 THEN
                                BEGIN

                                  Inc(spriteTime);

                                  if spriteTime>3 then
                                  begin
                                     spriteTime:=0;
                                     Inc(SubSprite);
                                     if SubSprite>2 then SubSprite:=1;
                                  end;

                                     INC(Sprite);

					IF Sprite> 3 THEN Sprite:=1;

					IF Position.xoffs<-(BlockSizeDiv-1) THEN
                                        BEGIN
					   DEC(Position.x);
					   Position.xoffs:=BlockSize+Position.xoffs;
					END;

					IF Position.xoffs>BlockSizeDiv THEN
                                        BEGIN
						INC(Position.x);
						Position.xoffs:=Position.xoffs-BlockSize;
					END;

					IF Position.yoffs<-(BlockSizeDiv-1) THEN
                                        BEGIN
						DEC(Position.y);
						Position.yoffs:=BlockSize+Position.yoffs;
					END;

					IF Position.yoffs>BlockSizeDiv THEN
                                        BEGIN
						INC(Position.y);
						Position.yoffs:=Position.yoffs-BlockSize;
					END;
				END;
			END;
		END;
	END;
END;

procedure Tmap.UpdateBricks;
var
	i,j,k: INTEGER;
BEGIN
	FOR i:=1 TO 16 DO
		FOR j:=1 TO 30 DO
                BEGIN
			IF Field[j,i].Flags AND 1<>0 THEN
                        BEGIN

				IF Field[j,i].Count=1 THEN
                                BEGIN
					Field[j,i].Flags:=Field[j,i].Flags AND $FF-2;
					Field[j,i].Flags:=Field[j,i].Flags OR 4+8;
				end;
				IF Field[j,i].IdleCount=0 THEN
                                BEGIN
					INC(Field[j,i].Count);
					IF Field[j,i].Count<6 THEN
                                        BEGIN
					   FOR k:=2 TO 10 DO
					    IF (Players[k].Controller<>0) THEN
					    IF (Players[k].Position.x=j) AND
                                               (Players[k].Position.y=i-1) THEN
                                            BEGIN
                                                Field[j,i].Count:=13-Field[j,i].Count;
                                                Field[j,i].Flags:=Field[j,i].Flags OR 2;
                                                Field[j,i].Flags:=Field[j,i].Flags AND $FE-4-8;
                                                Field[j,i].Count:=1;
                                                BREAK;
					    end;
					end;
					IF Field[j,i].Count=6 THEN
                                        BEGIN
						Field[j,i].IdleCount:=150;
					end;
				end
				ELSE
					DEC(Field[j,i].IdleCount);

				IF Field[j,i].Count=12 THEN
                                BEGIN
					Field[j,i].Flags:=Field[j,i].Flags OR 2;
					Field[j,i].Flags:=Field[j,i].Flags AND $FE-4-8;
					Field[j,i].Count:=1;
				end;
			end;
		end;
end;


procedure Tmap.Draw;
var
  i,j: Integer;
  boxsize2:integer;
  kx,kxx:Integer;
  ViewX:Integer;
 begin

  boxsize2:=-((Players[1].Position.x*BlockSize+Players[1].Position.xoffs)-512);

  DrawTextureBox(0,0,scrw,scrh,BackTexture[1]);

 for i:=1 to 16 do
 for j:=1 to 30 do
   with Field[j,i] do
   begin
   if (Flags and 128)=0 then
   if (Flags and 32)<>0 then
   if (Flags and 16)=0 then
   begin
    if (Flags and 1)=0 then
    DrawTextureBox(boxsize2+j*BlockSize,i*BlockSize,BlockSize,BlockSize,texture[Image]);
   end;
   end;


 for i:=1 to 10 do
  with Players[i] do
  begin
    IF Controller>0 THEN
    begin
     if Prizes>0 then
     DrawRectangle2D(boxsize2+Position.x*BlockSize+Position.xoffs,Position.y*BlockSize+Position.yoffs,BlockSize-2,BlockSize-2,$3CBEEA );
     kx:=0;
      if Controller=2 then kx:=1;
      DrawTextureBox2(boxsize2+Position.x*BlockSize+Position.xoffs,
                               Position.y*BlockSize+Position.yoffs,
                               BlockSize,
                               BlockSize,
                               PlayerPic[kx],
                               (32*HumanAnim[SpriteData,SubSprite])*TexW,
                               0,
                               (32)*TexW,
                               1
                     );

    end;
  end;

 for i:=1 to 16 do
 for j:=1 to 30 do
   with Field[j,i] do
   begin
    if (Flags and 128)=0 then
    if (Flags and 32)=0 then
    if (Flags AND 16)=0 then
    if (Flags and 1)=0 then
    DrawTextureBox(boxsize2+j*BlockSize,i*BlockSize,BlockSize,BlockSize,texture[Image]);
   end;

   if Paused then
     DrawTextureBox(scr2w-256,scr2h-128,512,256,StatusPic[1]);


   if EndOfGame then
   begin

    if (GameResult=1) or (GameResult=2)then
    DrawTextureBox(scr2w-256,scr2h-128,512,256,StatusPic[0]);

    if GameResult=10 then
    DrawTextureBox(scr2w-256,scr2h-128,512,256,StatusPic[2]);

   end;

   if ShowLevel then
   begin
   SText2D(MySysfont,inttostr(Level)+'/'+'144',350+2,582+2,0,255);
   SText2D(MySysfont,inttostr(Level)+'/'+'144',350,582,Rgb(255,255,255),255);
   end;

   if ShowLives then
   begin
   DrawTextureBox2(220,562,28,28,
                               PlayerPic[0],
                               (32*2)*TexW,
                               0,
                               (32)*TexW,
                               1
                     );
   SText2D(MySysfont,SetZero(Lives,1),260+2,582+2,0,255);
   SText2D(MySysfont,SetZero(Lives,1),260,582,Rgb(255,255,255),255);

   end;

   if ShowScore then
   begin
   SText2D(MySysfont,SetZero(Score,9),500+2,582+2,0,255);
   SText2D(MySysfont,SetZero(Score,9),500,582,Rgb(255,255,255),255);
   end;

 end;

procedure Tmap.RefreshLevel;
 begin
       ComputerReaction:=1;
       GameResult:=0;
       Paused:=FALSE;
       GameStarted:=False;
       EndOfGame:=FALSE;
       Load(Level);
 end;

procedure Tmap.Init;
var
i:integer;
 begin
  for i:=1 to 9 do
  LoadTexture('data\Gfx\Env'+inttostr(i)+'.png',Texture[i]);

  LoadTexture('data\Gfx\logo.jpg',BackTexture[0]);
  LoadTexture('data\Gfx\Back2.jpg',BackTexture[1]);
  LoadTexture('data\Gfx\Player.png',PlayerPic[0]);
  LoadTexture('data\Gfx\Player2.png',PlayerPic[1]);

  LoadTexture('data\Gfx\RFalure.png',StatusPic[0]);
  LoadTexture('data\Gfx\RPause.png',StatusPic[1]);
  LoadTexture('data\Gfx\RVictory.png',StatusPic[2]);

  HumanAnim[1,1]:=2;
  HumanAnim[1,2]:=3;
  HumanAnim[2,1]:=0;
  HumanAnim[2,2]:=1;
  HumanAnim[3,1]:=4;
  HumanAnim[3,2]:=5;
  HumanAnim[4,1]:=4;
  HumanAnim[4,2]:=5;
  HumanAnim[5,1]:=6;
  HumanAnim[5,2]:=6;
  HumanAnim[6,1]:=6;
  HumanAnim[6,2]:=7;
  HumanAnim[7,1]:=6;
  HumanAnim[7,2]:=8;
  HumanAnim[8,1]:=10;
  HumanAnim[8,2]:=10;
  HumanAnim[9,1]:=9;
  HumanAnim[9,2]:=9;


  ShowLives:=TRUE;
  ShowScore:=TRUE;
  ShowLevel:=TRUE;
  Lives:=5;
  Score:=0;

  Level:= 1;
  RefreshLevel;

 end;

procedure Tmap.Load(Number: BYTE);
Var
	InBuffer: POINTER;
	i,j,k,l,x,y: WORD;
	a,b,c: BYTE;
        F: File of byte;
        Ch: byte;

 begin

 TotalPrizes:=0;

    AssignFile(F, 'Data\Levels');
    Reset(F);
    Seek(F, 520*(Number-1));

    for i:=1 to 10 do
		with Players[i] do
                begin
			Command:=10;
			NewCommandWas:=FALSE;
			NewCommand:=10;
                        Read(F, Position.x);
                        Read(F, Position.y);
			Position.xoffs:=0;
			Position.yoffs:=0;
			Sprite:=1;
			SpriteData:=1;
                        Read(F, Colour);
                        Read(F, Controller);
			Prizes:=0;
                        spriteTime:=0;
                        SubSprite:=0;
                end;

   for i:=1 to 16 do
   for j:=1 to 30 do
    with Field[j,i] do
    begin
      Read(F, a);

      for b:=1 to 10 do
       if BrickFlags[b*2-1]=a then Flags:=BrickFlags[b*2];

        Count:=1;

       if a<64 then a:=a-47 else a:=a-63;

          Image:=a;
          IdleCount:=0;

        if Image=4 then INC(TotalPrizes);

      end;

    CloseFile(F);
    Level:=Number;
 end;

procedure Tmap.Close;
 begin
 end;

Procedure InitGame;
var
i:integer;
begin

 OpenLog;
 InitSoundEngine;
 Mymap.Init;
 PlayMusic('wurlitzr.mod');
end;

Procedure CloseGame;
var
  i:Integer;
begin
  for i:=0 to High(mymap.Texture) do
   glDeleteTextures(1,@mymap.Texture[i]);
   glDeleteTextures(1,@mymap.PlayerPic[0]);
   glDeleteTextures(1,@mymap.PlayerPic[1]);
   glDeleteTextures(1,@mymap.BackTexture[0]);
   glDeleteTextures(1,@mymap.BackTexture[1]);
   glDeleteTextures(1,@mymap.StatusPic[0]);
   glDeleteTextures(1,@mymap.StatusPic[1]);
   glDeleteTextures(1,@mymap.StatusPic[2]);
   FreeSoundEngine;
end;

procedure ProccesGame;
var
i:integer;
begin
// if Keys[VK_ESCAPE] then PostQuitMessage(0);

case GameStatus of
sGMenu:
       begin
       for i:=0 to 4 do
       if PointInRect(MousePos.X,MousePos.Y,290,204+i*46,180,40) then
       begin
         SelectMenu:=i;
         break;
       end;

        if Keys[MouseLB] then
         begin
           PlaySoundFromMEM(4);
         if SelectMenu=0 then
         begin
          GameStatus:= sGame;
           mymap.Lives:=5;
           mymap.Score:=0;
           mymap.Level:= 1;
           mymap.RefreshLevel;
           stopmusic;
            PlayMusic('subbass5.mod');
         end;

         if SelectMenu=4 then
         begin
           PostQuitMessage(0);
         end;

             Keys[MouseLB]:=false;
         end;

  if Keys[VK_ESCAPE] then
  begin
  if mymap.Paused then
  begin
  GameStatus:=sGame;
  mymap.Paused:=false;
  end;
  Keys[VK_ESCAPE]:=false;
  exit;
 end;


       end;
sGame: Mymap.UpdateLevel;
end;

end;


Procedure Render;
Var
 s:string;
 i,id,m:integer;
 Pt: TPoint;
 begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glPushMatrix;

 Enable2d(true);
 glblend(1);

case GameStatus of
 sGMenu:
      begin
      DrawTextureBox(0,0,scrw,scrh,mymap.BackTexture[0]);
      DrawRectangle2D(290,204+SelectMenu*46,180,40,$0,100,0,true,false);
      end;
 sGame: Mymap.Draw;
end;

  Enable2d(false);
  glPopMatrix;
  SwapBuffers(GWDC);

 end;

end.






