unit GMUtilite;

interface
      uses Windows,OpenGl,GMVars,SysUtils;


procedure Enable2d(A:boolean);
procedure glBlend(ID: Byte);
procedure VBL2(vsync : TVSyncMode);
procedure FreeSystemFont2D(font: DWORD); stdcall;
function GetTimer: integer;
function ExtractFileDir(const FileName: string): string;
function CreateSystemFont2D(AD:hDC;Face: PChar; W, H: integer): DWORD; stdcall;
procedure SText2D(font: DWORD; const str: string; X, Y, color: integer; Alpha : byte); stdcall;
procedure DrawRectangle2D(X, Y, Width, Height, Color:integer; Alpha : byte=255;Angle:integer=0; Fill : boolean = false;Center:boolean=false);
function IntToStr(x: integer): string;
function StrToInt(const S: string): Integer;
procedure DrawTextureBox(x,y,w,h:integer;textId:cardinal);
procedure DrawTextureBox2(x,y,w,h:integer;textId:cardinal;tx:Single=0;ty:Single=0;tv:single=1;tu:Single=1);
function PointInRect ( X, Y : Single; RX,RY,RW,RH : single   ) : Boolean;
function SetZero(Value:integer;ZeroCount:integer):string;
procedure ReadOptions(Name:string);
implementation
 uses IniFile,IDX_sound;

function SetZero(Value:integer;ZeroCount:integer):string;
var
i,k:integer;
s:string;
begin
  s:=inttostr(Value);
  i:=ZeroCount-length(s);
  if i<0 then i:=0;

  result:='';

  for k:=0 to i do
  result:=result+'0';

  result:=result+s;

end;

function ReadValueFromIniFile(Filename, Section, Key, Default: string):string; stdcall;
var ini : TIniFile;
begin
result:='';
if fileexists(Filename) then
begin
ini:=TIniFile.Create(Filename);
result:=ini.GetIniSectionKeyValue(Section,Key);

if result='-1' then result:=Default;
ini.Free;
end
else
  result:=Default;

end;

procedure ReadOptions(Name:string);
var
  ini : TIniFile;
  S:string;
  Loading:boolean;
  i,j,k,Myk:integer;
begin

 SCRW   :=strtoint(ReadValueFromIniFile(Name,'Screen','Width','800'));
 SCRH   :=strtoint(ReadValueFromIniFile(Name,'Screen','Height','600'));
 SCRBit :=strtoint(ReadValueFromIniFile(Name,'Screen','Bit','32'));
 SCRHZ  :=strtoint(ReadValueFromIniFile(Name,'Screen','Herz','60'));

 s:=ReadValueFromIniFile(Name,'Screen','Sync','1');
 if s='1' then Sync:=true else Sync:=false;

 s:=ReadValueFromIniFile(Name,'Screen','FullScreen','0');
 if s='1' then FullScreen:=true else FullScreen:=false;

 s:=ReadValueFromIniFile(Name,'Screen','CenterScreen','1');
 if s='1' then CenterScreen:=true else CenterScreen:=false;

 s:=ReadValueFromIniFile(Name,'Media','PlayMusic','0');
 if s='1' then playingmusic:=true else playingmusic:=false;

 s:=ReadValueFromIniFile(Name,'Media','PlaySound','0');
 if s='1' then playingsound:=true else playingsound:=false;

 SCR2W:=SCRW div 2;
 SCR2H:=SCRH div 2;;

end;

function PointInRect ( X, Y : Single; RX,RY,RW,RH : single   ) : Boolean;
begin
  Result := ( X > RX ) and ( X < RX + RW ) and
            ( Y > RY ) and ( Y < RY + RH );
end;

procedure DrawTextureBox(x,y,w,h:integer;textId:cardinal);
begin
   glColor3f(1,1,1);
  glEnable( GL_TEXTURE_2D );
  glPushMatrix();
  glTranslatef(X,Y,0);
                glBindTexture(GL_TEXTURE_2D, textId); // use floor
                glBegin(GL_QUADS);
		glTexCoord2f(0,1);  glVertex2f(0, 0);
		glTexCoord2f(1,1);  glVertex2f(0+w,0);
		glTexCoord2f(1,0);  glVertex2f(0+w, 0+h);
		glTexCoord2f(0,0);  glVertex2f(0,0+h);
	        glEnd();
  glPopMatrix();
  glDisable( GL_TEXTURE_2D );

end;

procedure DrawTextureBox2(x,y,w,h:integer;textId:cardinal;tx:Single=0;ty:Single=0;tv:single=1;tu:Single=1);
begin
   glColor3f(1,1,1);
  glEnable( GL_TEXTURE_2D );
  glPushMatrix();
  glTranslatef(X,Y,0);
                glBindTexture(GL_TEXTURE_2D, textId); // use floor
                glBegin(GL_QUADS);
		glTexCoord2f(tx,ty+tu);  glVertex2f(0, 0);
		glTexCoord2f(tx+tv,ty+tu);  glVertex2f(0+w,0);
		glTexCoord2f(tx+tv,ty);  glVertex2f(0+w, 0+h);
		glTexCoord2f(tx,ty);  glVertex2f(0,0+h);
	        glEnd();
  glPopMatrix();
  glDisable( GL_TEXTURE_2D );
 
end;


//   
function IntToStr(x: integer): string;
begin
Str(x, Result);
end;

function StrToInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
end;


procedure DrawRectangle2D(X, Y, Width, Height, Color:integer; Alpha : byte=255;Angle:integer=0; Fill : boolean = false;Center:boolean=false);
var
Rx,Ry:real;
begin

glPushMatrix;

glTranslatef(X,Y,0);

if Angle<>0 then glrotatef(Angle,0,0,1);
if Alpha<>255 then glEnable(GL_BLEND);

 if fill then
 begin

  glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
   glBegin(GL_QUADS);
  if center then
  begin
      Rx:=Width/2;
      Ry:=Height/2;
    glVertex2f(-rx,-ry);
    glVertex2f(rx,-ry);
    glVertex2f(rx,ry);
    glVertex2f(-rx,ry);
 end
 else
 begin
    glVertex2f(0,0);
    glVertex2f(0+Width,0);
    glVertex2f(0+Width,0+Height);
    glVertex2f(0,0+Height);
 end;

   glEnd;

 end else
 begin

  glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
   glBegin(GL_LINE_STRIP);
     if center then
  begin
      Rx:=Width/2;
      Ry:=Height/2;

    glVertex2f(-rx,-ry);
    glVertex2f(rx,-ry);
    glVertex2f(rx,ry);
    glVertex2f(-rx,ry);
    glVertex2f(-rx,-ry);
   end
   else
   begin

    glVertex2f(0,0);
    glVertex2f(0+Width,0);
    glVertex2f(0+Width,0+Height);
    glVertex2f(0,0+Height);
    glVertex2f(0,0-1);

   end;

   glEnd;

 end;
 glPopMatrix;

if Alpha<>255 then glDisable(GL_BLEND);
end;

procedure SText2D(font: DWORD; const str: string; X, Y, color: integer; Alpha : byte); stdcall;
begin
glPushMatrix();

if Alpha<>255 then
  glEnable(GL_BLEND);
 glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
 glRasterPos2f(X, Y);
 glListBase(font);
 glCallLists(Length(str), GL_UNSIGNED_BYTE, PChar(str));
if Alpha<>255 then
  glDisable(GL_BLEND);
glPopMatrix();
end;



function CreateSystemFont2D(AD:hDC;Face: PChar; W, H: integer): DWORD; stdcall;
var
 font : HFONT;
begin
Result := glGenLists(256);
font := CreateFont(H, W, 0, 0, 0, 0, 0, 0,RUSSIAN_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                   ANTIALIASED_QUALITY, FW_BOLD {or FF_DONTCARE or DEFAULT_PITCH}, Face);
SelectObject(AD, font);
wglUseFontBitmaps(AD, 0, 256, Result);
DeleteObject(font);
end;


function ExtractFileDir(const FileName: string): string;
var
  I: Integer;
begin
  I := LastDelimiter(PathDelim + DriveDelim,Filename);
  if (I > 1) and (FileName[I] = PathDelim) and
    (((FileName[I - 1] <> PathDelim) and (FileName[I-1] <> DriveDelim)) or
    (ByteType(FileName, I-1) = mbTrailByte)) then Dec(I);
  while (ByteType(FileName, I-1) = mbTrailByte) and (I > 0) do Dec(I);
  Result := Copy(FileName, 1, I);
end;


function GetTimer: integer;
var
T : LARGE_INTEGER;
F : LARGE_INTEGER;
begin
QueryPerformanceFrequency(Int64(F));
QueryPerformanceCounter(Int64(T));
result := round(1000 * T.QuadPart / F.QuadPart);
end;



procedure FreeSystemFont2D(font: DWORD); stdcall;
begin
glDeleteLists(font, 256);
end;


procedure VBL2(vsync : TVSyncMode);
var
   i : Integer;
begin
   if WGL_EXT_swap_control then
   begin
      i := wglGetSwapIntervalEXT;
      case VSync of
         vsmSync    : if i<>1 then wglSwapIntervalEXT(1);
         vsmNoSync  : if i<>0 then wglSwapIntervalEXT(0);
      else
         Assert(False);
      end;
   end;

end;


//   //
procedure glBlend(ID: Byte);
begin
if ID = 0 then
 glDisable(GL_BLEND)
else
 begin
 glEnable(GL_BLEND);
  case ID of
   1 : glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   2 : glBlendFunc(GL_SRC_ALPHA, GL_ONE);
   3 : glBlendFunc(GL_ZERO, GL_SRC_COLOR);
  end;
 end;
end;

procedure Enable2d(A:boolean);
begin
 if A then
 begin
  glDisable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity;
  gluOrtho2D(0,SCRW,SCRH,0);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix;
  glLoadIdentity;
 end
 else
 begin
   glPopMatrix;
  glMatrixMode(GL_PROJECTION);
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
  glEnable(GL_DEPTH_TEST);
 end;

 end;



end.
