unit Main;

interface

uses
  Windows,
  Messages,
  OpenGL,
  Global,
  Use_OpenGL,
  Use_Geometry,
  Use_3d,
  Use_jpg,
  anim_man,
  TGA2;

procedure TactTimer;
procedure Create_prog;
procedure Kill_Prog;

implementation

procedure Save_Level(name:string);
Var
 i,j:integer;
 F:File of TLevel;L:TLevel;
begin
 for i:=0 to MapX do
  for j:=0 to MapY do
    L.cell[i,j]:=Cell[i,j];
 for i := 0 to Max_Obj do
   L.obj[i]:=obj[i];
 AssignFile(F,name);
 Rewrite(F);
 write(F,L);
 CloseFile(F);
end;

procedure Load_Level(name:string);
Var
 i,j,z:integer;
 F:File of TLevel;L:TLevel;
begin
 AssignFile(F,name);
 reset(F);
 read(F,L);
 CloseFile(F);
 for i:=0 to MapX do
  for j:=0 to MapY do
    cell[i,j]:=L.Cell[i,j];
 for i := 0 to Max_Obj do
   obj[i]:=L.obj[i];
 j:=2;
 for i := 0 to Max_Obj do
   if (obj[i].tip=ot_input) then
    begin
     j:=j+1;
     if (obj[i].man<>0) then obj[i].man:=j;
     obj[i].faze:=1;
     Mans[obj[i].man].real:=false;
     Mans[obj[i].man].kx:=obj[i].kx;
     Mans[obj[i].man].ky:=obj[i].ky;
     Mans[obj[i].man].Point:=Point(Mans[i].KX+0.5,Mans[i].KY,1);
    end;
 for i := 0 to Max_Obj do
   if (obj[i].tip=ot_exit) then
    begin
     obj[i].faze:=0;
    end;
end;

procedure add_obj(x,y,tip,faze,man:integer);
Var i:integer;
begin
 for I := 0 to Max_Obj do
  if obj[i].tip=0 then
  begin
    obj[i].kx:=x;
    obj[i].ky:=y;
    obj[i].tip:=tip;
    obj[i].faze:=faze;
    obj[i].man:=man;
    break;
  end;
end;

procedure add_hero_obj(x,y:integer);
Var i:integer;
begin
 for I := 0 to Max_Obj do
  if (obj[i].tip=ot_input) and (obj[i].man=0) then
  begin
    obj[i].kx:=x;
    obj[i].ky:=y;
    obj[i].tip:=ot_input;
    obj[i].faze:=0;
    obj[i].man:=0;
    break;
  end;
end;

procedure add_man_obj(x,y:integer);
Var i,j:integer;
begin
 for I := 0 to Max_Obj do
  if (obj[i].tip=ot_input) then
  begin
   if (obj[i].man>j) then
     j:=obj[i].man;
   if j=0 then j:=1;   
  end;
 add_obj(x,y,ot_input,0,j+1);
end;

procedure put_diamond(x,y,z:single;faze:integer);
begin
 glTranslatef((x+0.5)*Mash,y*Mash,(z+0.5)*Mash);
 Diamond.RenderScale(1-faze*0.05);
 Diamond.Render(Diamond.Texture);
 Diamond.RenderRestore;
 glTranslatef(-(x+0.5)*Mash,-y*Mash,-(z+0.5)*Mash);
end;

procedure put_door(x,y,z:single;anim:integer);
begin
 if (anim<1) and not edit_mode then exit;
 glTranslatef((x)*Mash,y*Mash,(z)*Mash);
 if anim>600 then anim:=1200-anim;
 Door.anim(abs(anim/100));
 if edit_mode then
  Door.anim(500);
 Door.Render(door.Texture);
 glTranslatef(-(x)*Mash,-y*Mash,-(z)*Mash);
end;

procedure put_obj;
Var i:integer;
begin
 for I := 0 to Max_Obj do
  case obj[i].tip of
   0:;
   ot_input:Put_door(obj[i].kx-kx,obj[i].ky-ky,-kz,obj[i].faze); { ot_input   }
   ot_exit:Put_door(obj[i].kx-kx,obj[i].ky-ky,-kz,obj[i].faze); {ot_exit}
   ot_diamond:Put_diamond(obj[i].kx-kx,obj[i].ky-ky,-kz,obj[i].faze); {ot_diamond }
  end;
end;

procedure put_rope(x,y,z:single);
begin
 glTranslatef(x*Mash,y*Mash,z*Mash);
 rope.Render(Tex[5]);
 glTranslatef(-x*Mash,-y*Mash,-z*Mash);
end;

procedure put_grid(x,y,z:single;t:byte);
begin
 glTranslatef(x*Mash,y*Mash,z*Mash);
 gr.Render(Tex[4]);
 glTranslatef(-x*Mash,-y*Mash,-z*Mash);
end;

procedure put_rock(x,y,z:single;t:byte);
begin
 glTranslatef(x*Mash,y*Mash,z*Mash);
 Box.Render(Tex[t]);
 glTranslatef(-x*Mash,-y*Mash,-z*Mash);
end;

procedure put_box(x,y,z:single;t:integer);
begin
 if t>0 then
 begin
 glTranslatef(x*Mash,y*Mash,z*Mash);
  Box.Render(Alpha[t]);
 glTranslatef(-x*Mash,-y*Mash,-z*Mash);
 end;
end;

procedure put_level;
Var i,j,bx,by,ex,ey,f:integer;
begin
 f:=15;
 if edit_mode then
  f:=40;
 bx:=Mans[0].kx-f; if bx<0 then bx:=0;
 by:=Mans[0].ky-f; if by<0 then by:=0;
 ex:=Mans[0].kx+f; if ex>MapX then ex:=MapX;
 ey:=Mans[0].ky+f; if ey>MapY then ey:=MapY;
 for i:=bx to ex do
  for j:=by to ey do
   begin
   case cell[i,j].tip of
    ct_none:put_box(i-kx,j-ky,-kz,(trunc((cell[i,j].hided-hide_time+30)/3)));
    ct_rock:put_Rock(i-kx,j-ky,-kz,cell[i,j].sprite);
    ct_wall:put_box(i-kx,j-ky,-kz,10-trunc(cell[i,j].hided/3));
    ct_rope:put_rope(i-kx,j-ky,-kz);
    ct_grid:put_grid(i-kx,j-ky,-kz,cell[i,j].sprite);
   end;
 //  if (Map[i,j]>1) and (Map[i,j]<12) then Put_diamond(i-kx,j-ky,-kz); {test}
  end;
end;

procedure put_detail(num:integer;Point:TPoint);
begin
 glTranslatef((-KX+Point[0])*Mash,(-KY+Point[1])*Mash,(-KZ+Point[2])*Mash);
 Mashinikum[num].Anim(Anim/100);
 Mashinikum[num].Render(Tex[6]);
 glTranslatef(-(-KX+Point[0])*Mash,-(-KY+Point[1])*Mash,-(-KZ+Point[2])*Mash);
end;

procedure put_BackGround;
begin
 anim:=anim+3;
 if anim>400 then
  anim:=0;
 put_detail(2,Point(3,2,50));
 put_detail(1,Point(-12,2,40));
 put_detail(4,Point(24,1,45));
 put_detail(2,Point(3,2,50));
 put_detail(1,Point(23,2,42));
 put_detail(5,Point(20,2,40));
 put_detail(2,Point(29,6,10));
 put_detail(2,Point(12,6,10));
 put_detail(2,Point(4,6,10));
 put_detail(5,Point(6.5,8,10));
 put_detail(3,Point(14,3,10));
 put_detail(1,Point(45,2,-3));
 put_detail(4,Point(43,3,-2));
end;

procedure put_enemy(Var Enemy:TMan);
begin
 anim_(Enemy,Enemy_Anim_Tact);
 glTranslatef((-KX+Enemy.Point[0])*Mash,(-KY+Enemy.Point[1])*Mash,(-KZ+Enemy.Point[2])*Mash);
 glRotatef(Enemy.ang,0,1,0);
 Man.Render(Tex[7]);
 glRotatef(-Enemy.ang,0,1,0);
 glTranslatef(-(-KX+Enemy.Point[0])*Mash,-(-KY+Enemy.Point[1])*Mash,-(-KZ+Enemy.Point[2])*Mash);
end;

procedure Check_Keys;       { }
//Var P:TPoint;
Var zx,zy:integer;
begin
 DX:=((+MX-PW/2)*0.0129/mash)+kx;
 DY:=((-MY+PH/2)*0.0129/mash)+ky; {   }
{}
 if key[16] then
 begin
   key[16]:=false;
   free_look:=not free_look;
 end;
 if free_look then
  begin
   AX:=AX-(MY-trunc(PH/2))/15;
   If AX<0 then AX:=0;
   If AX>180 then AX:=180;
   AY:=AY+(MX-trunc(PW/2))/15;
   SetCursorPos(Trunc(PW/2),Trunc(PH/2));
  end else
  begin
    AX:=Get_R(90+(Mans[0].Point[1]-MapY/2)*0.8);
    Ay:=Get_R(-(Mans[0].Point[0]-MapX/2)*0.8);
  end;
 If MW>0 then TCM:=TCM+(TCM)*0.3;
 If MW<0 then TCM:=TCM-(TCM)*0.3;
 If TCM>12 then TCM:=12;
 If TCM<0.3 then TCM:=0.3;
 MW:=0;

 if key[192] then begin key[192]:=false;Edit_Mode:=not Edit_Mode; end;
 if Edit_Mode then
 begin {edit mode}
  if (key[65] or key[37]) then begin KX:=KX-1;key[65]:=false;key[37]:=false;end;
  if (key[68] or key[39]) then begin KX:=KX+1;key[68]:=false;key[39]:=false;end;
  if (key[87] or key[38]) then begin KY:=KY+1;key[87]:=false;key[38]:=false;end;
  if (key[83] or key[40]) then begin KY:=KY-1;key[83]:=false;key[40]:=false;end;
  zx:=trunc(KX);
  zy:=trunc(KY);
  if key[49] and (Get_tip(zx,zy)>=0) then begin Cell[zx,zy].tip:=ct_none;Cell[zx,zy].sprite:=0;key[49]:=false;end;{ct_none}
  if key[50] and (Get_tip(zx,zy)>=0) then begin Cell[zx,zy].tip:=ct_rock;Cell[zx,zy].sprite:=Random(3);key[50]:=false;end;{ct_rock}
  if key[51] and (Get_tip(zx,zy)>=0) then begin Cell[zx,zy].tip:=ct_wall;Cell[zx,zy].sprite:=3;key[51]:=false;end;{ct_ground}
  if key[52] and (Get_tip(zx,zy)>=0) then begin Cell[zx,zy].tip:=ct_rope;Cell[zx,zy].sprite:=0;key[52]:=false;end;{ct_rope}
  if key[53] and (Get_tip(zx,zy)>=0) then begin Cell[zx,zy].tip:=ct_grid;Cell[zx,zy].sprite:=Random(3);key[53]:=false;end;{ct_grid}
  if key[54] then begin key[54]:=false;end;
  if key[69] then begin key[69]:=false;add_obj(zx,zy,ot_diamond,0,0); end;
  if key[82] then begin key[82]:=false;add_hero_obj(zx,zy); end;
  if key[84] then begin key[84]:=false;add_man_obj(zx,zy); end;
  if key[89] then begin key[89]:=false;add_obj(zx,zy,ot_exit,0,0); end;
  if key[112] then begin Save_Level('test_level.txt');key[112]:=false;end;
  if key[113] then begin Load_Level('test_level.txt');key[113]:=false;end;
 end else
 if Mans[0].real then 
 begin  {moving and control}
  if (key[65] or key[37]) and (Mans[0].act=0) then begin move(1,Mans[0]);{hero.kx:=hero.kx-1;hero.act:=anim_tact;hero.faze:=1;{key[65]:=false;key[37]:=false;}end else
  if (key[68] or key[39]) and (Mans[0].act=0) then begin move(0,Mans[0]);{hero.kx:=hero.kx+1;hero.act:=anim_tact;hero.faze:=2;{key[68]:=false;key[39]:=false;}end else
  if (key[87] or key[38]) and (Mans[0].act=0) then begin move(2,Mans[0]);{hero.ky:=hero.ky+1;hero.act:=anim_tact;hero.faze:=3;{KY:=KY+0.333;key[87]:=false;key[38]:=false;}end else
  if (key[83] or key[40]) and (Mans[0].act=0) then begin move(3,Mans[0]);{hero.ky:=hero.ky-1;hero.act:=anim_tact;hero.faze:=4;{KY:=KY-0.333;key[83]:=false;key[40]:=false;}end;
 if key[81] then        {q}
  begin           
   key[81]:=false;
   if (Cell[Mans[0].kx-1,Mans[0].ky-1].tip=ct_wall) and
     (Cell[Mans[0].kx-1,Mans[0].ky-1].hided=0) then
    Cell[Mans[0].kx-1,Mans[0].ky-1].hided:=1;
  end;
 if key[69] then        {e}
  begin
   key[69]:=false;
   if (Cell[Mans[0].kx+1,Mans[0].ky-1].tip=ct_wall) and
     (Cell[Mans[0].kx+1,Mans[0].ky-1].hided=0) then
    Cell[Mans[0].kx+1,Mans[0].ky-1].hided:=1;
  end;
 end;  
 if not Edit_Mode then
 begin            
 KX:=Mans[0].Point[0];
 KY:=Mans[0].Point[1];
 KZ:=Mans[0].Point[2];    
 end;      
 if key[109] then
  begin
   load_Level('Clear.txt');
   key[109]:=false;
  end;
 if key[27] then  {esc}
  begin
  //key[27]:=false;
   Kill_Prog;
  end;
end;

procedure Check_Map;
Var i,j,q,z:integer;
begin
 j:=0;
 for i:=0 to Max_obj do
  case obj[i].tip of
   ot_input:if obj[i].faze>0 then
    begin
     if (Obj[i].faze=1) and (Obj[i].man=0) then
      begin
       for z:=0 to Max_Obj do if obj[z].tip=ot_input then begin obj[z].faze:=1;end;
       for z:=1 to Max_Man do Mans[z].real:=false;
      end;
     obj[i].faze:=obj[i].faze+5;
     if (obj[i].faze>=501) and not Mans[obj[i].man].real and (obj[i].man<=Max_Man) then
      begin {man creation}
       Mans[obj[i].man].tx:=0;
       Mans[obj[i].man].ty:=0;
       Mans[obj[i].man].needang:=0;
       Mans[obj[i].man].ang:=0;
       Mans[obj[i].man].kx:=obj[i].kx;
       Mans[obj[i].man].ky:=obj[i].ky;
       Mans[obj[i].man].Point:=Point(Mans[i].KX+0.5,Mans[i].KY,1);
       Mans[obj[i].man].faze:=25;
       Mans[obj[i].man].anim:=100;
       if i=0 then
        Mans[obj[i].man].act:=man_anim_tact else
        Mans[obj[i].man].act:=Enemy_anim_tact;
       Mans[obj[i].man].real:=true;
      end;
     if obj[i].faze>=1200 then
      obj[i].faze:=0;   
    end;
   ot_diamond:
   begin
    j:=j+1;
    if (Mans[0].kx=Obj[i].kx) and (Mans[0].ky=Obj[i].ky)
     and (obj[i].faze=0) then
     obj[i].faze:=1;
    if obj[i].faze>0 then obj[i].faze:=obj[i].faze+1;
    if obj[i].faze>20 then Obj[i].tip:=0;
   end;
  end;
 {exit creating}
 for i:=0 to Max_Obj do
  if (obj[i].tip=ot_exit) then
  begin
   if j>0 then  obj[i].faze:=1;
   if (j=0) and (obj[i].faze=0) then obj[i].faze:=1;
   if (obj[i].faze>0) and (obj[i].faze<501) then obj[i].faze:=obj[i].faze+5;
   if (Mans[0].kx=Obj[i].kx) and (Mans[0].ky=Obj[i].ky)
     and (obj[i].faze>500) then
    begin
     if (Mans[0].act=0) and (Mans[0].real) and (mans[i].faze<>26) then
      begin
       Mans[0].fx:=0;
       Mans[0].fy:=0;
       Mans[0].tx:=0;
       Mans[0].ty:=0;
       Mans[0].act:=man_anim_tact;
       Mans[0].faze:=26;
       Mans[0].needang:=180;
      end;
    // Mans[0].real:=false;
     for z:=1 to Max_Man do
      Mans[i].real:=false;
     obj[i].faze:=obj[i].faze+5;
     if obj[i].faze>=670 then
      begin
       Mans[0].real:=false;
       Mans[0].faze:=0;
      end;
     if obj[i].faze>=1200 then
     begin
      obj[i].faze:=0;
            {end game 1!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
      case i of
       2:Load_Level('data/Lev1.txt');
       3:Load_Level('data/Lev2.txt');
       4:Load_Level('data/Lev3.txt');
       5:Load_Level('data/Lev4.txt');
       6:Load_Level('data/Lev5.txt');
       7:Load_Level('data/Lev6.txt');
       8:Load_Level('data/Lev7.txt');
       9:Load_Level('data/Lev8.txt');
       else Load_Level('data/Menu.txt');
      end;
     end;
    end;
  end;
for i:=1 to Max_Man do
 if Mans[i].real then
 if (Mans[i].kx=Mans[0].kx) and (Mans[i].ky=Mans[0].ky) then
  begin
   Mans[0].real:=false;//true;
   Mans[0].Point:=Point(Mans[0].KX+0.5,Mans[0].KY,1);
   Obj[0].faze:=1;
   for z := 0 to Max_man do
    Mans[z].act:=0;
  end;
{cubes hiding}
 for i:=0 to MapX do
  for j:=0 to MapY do
   begin
    if (Cell[i,j].tip=ct_none) then
     if (Cell[i,j].hided>0) then
      begin
       Cell[i,j].hided:=Cell[i,j].hided+1;
       if Cell[i,j].hided>hide_time then
        begin
         Cell[i,j].tip:=ct_wall;
         Cell[i,j].Hided:=0;
        end;
      end;
    if Cell[i,j].tip=ct_wall then
     if Cell[i,j].hided>0 then
      begin
       Cell[i,j].hided:=Cell[i,j].hided+1;
       if Cell[i,j].hided>30 then
        begin
         Cell[i,j].tip:=ct_none;
         Cell[i,j].hided:=1;
        end;
      end;
   end;
 {bots moving}
 {way map}
 find_Ways;
 for i:=1 to Max_Man do
  if (Mans[i].real) and (Mans[i].act=0) then
  begin
   j:=can_move(Mans[i].kx,Mans[i].ky);
  // if j<0 then j:=10000;
   z:=-1;
   q:=j;
//   if q>j then q:=j;
   if (q>can_move(Mans[i].kx-1,Mans[i].ky)) and (can_move(Mans[i].kx-1,Mans[i].ky)>=0) then
   begin
     q:=can_move(Mans[i].kx-1,Mans[i].ky);
     z:=1;
   end;
   if (q>can_move(Mans[i].kx+1,Mans[i].ky)) and (can_move(Mans[i].kx+1,Mans[i].ky)>=0) then
   begin
     q:=can_move(Mans[i].kx+1,Mans[i].ky);
     z:=0;
   end;
   if (q>can_move(Mans[i].kx,Mans[i].ky-1)) and (can_move(Mans[i].kx,Mans[i].ky-1)>=0) then
   begin
     q:=can_move(Mans[i].kx,Mans[i].ky-1);
     z:=3;
   end;
   if (q>can_move(Mans[i].kx,Mans[i].ky+1)) and (can_move(Mans[i].kx,Mans[i].ky+1)>=0) then
   begin
     q:=can_move(Mans[i].kx,Mans[i].ky+1);
     z:=2;
   end;
   Move(z,Mans[i]);
 end;
  move_man;
  for i:=0 to Max_Man do
   if Mans[i].real then
    if Cell[mans[i].kx,mans[i].ky].tip=ct_Wall then
    begin
     for j:= 0 to Max_Obj do
      if (obj[j].tip=ot_input) and (obj[j].man=i) then
       begin
        mans[i].real:=false;
        obj[j].faze:=1;
        Mans[i].kx:=obj[j].kx;
        Mans[i].ky:=obj[j].ky;
        if i=0 then
         begin
          Mans[obj[j].man].Point:=Point(Mans[i].KX+0.5,Mans[i].KY,1);
         end;
       end;
    end;
end;

procedure Render;    {}
Var
  i{,j}:integer;
//  P:TVector4f;
begin
 glclear(GL_Color_Buffer_Bit xor GL_Depth_Buffer_Bit);  {}
 glLoadIdentity();     {}
{render}
 glTranslatef(0,0,TCM-10);
 glRotatef(-90,1,0,0);
 glRotatef(AX,1,0,0);
 glRotatef(-AY,0,1,0);
 glColor4f(5,5,5,5);
 glColor4f(4,4,4,5);
 Anim_(Mans[0],man_anim_tact);
 gltranslatef(0,0,0.5*Mash);
 glRotatef(Mans[0].ang,0,1,0);
 if Mans[0].real then Man.Render(Man.Texture);
 glRotatef(-Mans[0].ang,0,1,0);
 for i:=1 to Max_Man do
  if Mans[i].real then Put_Enemy(Mans[i]);
 gltranslatef(0,0,-0.5*Mash);
 put_level;
 put_obj;
 put_BackGround;
 {render}
 glFlush();
 SwapBuffers(glhDC);
end;

procedure TactTimer;  { }
begin
// if not key[32] then exit;
 Check_Keys;    {    }
 if Game_Mode=-1 then Kill_Prog;
 Check_Map;
 Render;        {}
end;

procedure Create_prog;{ }
Var i,j,z:integer;
begin
 ShowCursor(false);  { }
 glClearColor(0.0,0.0,0.0,5);
 enable_bind_tex;
 glShadeModel(GL_SMOOTH);
 Gen_Font(glhDC);
 glEnable(GL_Depth_Test);
 glEnable(GL_Blend);
 AX:=90;
 KX:=20+0.5;
 KY:=20;
 TCM:=4;
 {hero}
{ Mans[0].faze:=25;
 Mans[0].anim:=100;
 Mans[0].act:=anim_tact;   }
 Mans[0].kx:=9;
 Mans[0].ky:=1;
 Mans[0].real:=false;//true;
 Mans[0].Point:=Point(Mans[0].KX+0.5,Mans[0].KY,1);
 Add_obj(Mans[0].kx,Mans[0].ky,1,1,0);
{ for i:=1 to Max_Man do
  begin
   Mans[i].real:=false;
   Mans[i].kx:=12+i;
   Mans[i].ky:=1;
   Mans[i].Point:=Point(Mans[i].KX+0.5,Mans[i].KY,1);
   Mans[i].anim:=0;
   Add_obj(Mans[i].kx,Mans[i].ky,1,1,i);
  end;   }
 Game_Mode:=0;
 {test level}
 for i:=0 to MapX do
  begin
   Cell[i,0].tip:=1;
   Cell[i,0].sprite:=Random(3);
  end;
 //Load_level('data/Lev1.txt');
 Load_level('data/Menu.txt');
 {game loads}
 for i:=0 to 10 do
 Tex[i]:=i+155;
 Man:=TMesh.Create;
 Man.LoadFromMMSFile('data/hero.mms');
 //Man.SaveMMSFile('data/hero.mms');
 LoadJPGTexture('data/hero.jpg',Man.Texture);
 LoadJPGTexture('data/enemy.jpg',Tex[7]);
 Man.Scale(1/51);
 Man.Scale(Mash);
 Box:= TMesh.Create;
 Box.LoadFromMMSFile('data/Rock.mms');
 Box.Scale(Mash);
 door:=TMesh.Create;
 door.LoadFromMMSFile('data/door.mms');
 door.Scale(1/50);
 door.Scale(Mash);
 gr:=TMesh.Create;
 gr.LoadFromMMSFile('data/grid.mms');
 gr.Scale(1/50);
 gr.Scale(Mash);
 rope:=TMesh.Create;
 rope.LoadFromMMSFile('data/rope.mms');
 rope.Scale(Mash);
 for i:=1 to 5 do
   begin
     Mashinikum[i]:=TMesh.Create;
     Mashinikum[i].LoadFromMMSFile('data/Mashinikum/Mashinikum_'+intToStr(i)+'.mms');
     Mashinikum[i].Scale(1/30);
     Mashinikum[i].Scale(Mash);
   end;
 for i:=1 to 9 do
  alpha[i]:=100+Random(400);
 for i:=1 to 9 do
  LoadJPGATexture('data/kirpich.jpg','data/alpha/alpha_'+IntToStr(i)+'.jpg',alpha[i]);
 diamond:=TMesh.Create;
 diamond.LoadFromMMSFile('data/diamond.mms');
 diamond.Scale(1/50);
 diamond.Scale(Mash);
 LoadJPGTexture('data/diamond.jpg',diamond.Texture);
 LoadJPGTexture('data/Metall.jpg',Tex[0]);
 LoadJPGTexture('data/Metall1.jpg',Tex[1]);
 LoadJPGTexture('data/Metall2.jpg',Tex[2]);
 LoadJPGTexture('data/kirpich.jpg',alpha[10]);
 LoadJPGTexture('data/door.jpg',door.Texture);
 LoadJPGTexture('data/rope.jpg',Tex[5]);
 LoadJPGTexture('data/grid.jpg',Tex[4]);
 LoadJPGTexture('data/Mashinikum.jpg',Tex[6]);
end;

procedure Kill_Prog;
Var i:byte;
begin
 ChangeDisplaySettings(devMode(nil^), 0);{ }
 ShowCursor(True);        { }
 KillTimer(0,TactH);     { }
{ Box.Destroy;
 Man.Destroy;
 door.Destroy;
 gr.Destroy;
 rope.Destroy; }
 for i:=1 to 5 do
   begin
     Mashinikum[i].Destroy;
   end;
 diamond.Destroy;
 if glhRC<>0 then
 begin
  wglMakeCurrent(glhDC,0);
  wglDeleteContext(glhRC);
 end;
 if glhDC<>0 then ReleaseDC(hWnd, glhDC);
 exitprocess(0);
end;

end.
