unit Use_3d;

interface

{
0.002

}

Uses OpenGl,Use_Geometry,SysUtils;

type
 TFace = array [0..2] of integer;{triangle Face}
 TVertex = array of TPoint;
 TFaces = Array of TFace;

 TMesh = class
 private
 public
  num_Vertex:cardinal;
  num_Faces:cardinal;
  num_Tex_Vertex:cardinal;
 // num_Tex:cardinal;
  num_anim:cardinal;
  Vertex:Array of TVertex; {array of vertex coords (array for animation)}
  Render_Vertex:TVertex;{vertex coords for render}
  Face:TFaces;       {number each vertex in triangles}
  TexV:Array of TVect;  {texture coordinates}
  Tex:Array of TFace;   {number each texture vertex in triangles }
  Normal:Array of TPoint; {normals fop each point}
  Texture:cardinal;       {texture num}
  constructor Create();
  procedure Anim(L:single);{animation between L and L+1 frame}
  procedure AnimBetween(L:single;B,E:integer);{animation between L and N frame}
  procedure Render(tx:cardinal);
  procedure RenderScale(F:Single);
  procedure RenderRestore;
  procedure Scale(F:Single);
  procedure set_val(Var s:string;M,c:byte;var i:Cardinal; var j:Cardinal;var z:Cardinal; var L:Cardinal);  procedure LoadFromMMSFile(FileName:String);
  procedure Test(name:string);  {test}
  procedure Add_Load(Name:String);   {adding new geometry in this mesh}
  procedure SaveMMSFile(Name:String); {save mms format vith minimum faces,norms and tex}
 end;

Var
  Man:TMesh;
  Box:TMesh;
  gr,rope,door,diamond:TMesh;
  Mashinikum:array[1..5] of TMesh;

implementation
{!!!}
Var
 anim:byte;
 //test_:boolean = false;
  {Meshes}


constructor TMesh.Create();
begin
 num_Vertex:=5;
 num_Faces:=5;
 num_Tex_Vertex:=5;
 Texture:=255+Random(256);{ :)}
 SetLength(Vertex,5);
 SetLength(Face,5);
 SetLength(TexV,5);
 SetLength(Tex,5);
 SetLength(Normal,5);  
 SetLength(Render_Vertex,num_vertex);
end;

procedure TMesh.Anim(L:single);
Var i,a:cardinal;
begin
 if L<0 then L:=0;
 If L>num_Anim then L:=num_Anim;
 a:= Trunc(L);
 If (L=a) then
  Render_Vertex:=copy(Vertex[a]) else
  For i:=0 to num_vertex do
   begin
    Render_Vertex[i]:=Between(Vertex[a][i],Vertex[a+1][i],L-a);
   end;
end;

procedure TMesh.AnimBetween(L:single;B,E:integer);{animation between L and N frame}
Var i:cardinal;
begin
 if B<0 then B:=0;
 If B>num_Anim then B:=num_Anim;
 if E<0 then E:=0;
 If E>num_Anim+1 then E:=num_Anim+1;
 if L<0 then L:=0;
 if L>1 then L:=1;
 If (L=0) then
  Render_Vertex:=copy(Vertex[B]) else
  For i:=0 to num_vertex do
   begin
    Render_Vertex[i]:=Between(Vertex[B][i],Vertex[E][i],L);
   end;
end;

procedure TMesh.Render(tx:cardinal);
Var i,j:integer;
begin
 glEnable(GL_Texture_2d);
 glBindTexture(GL_Texture_2d,Tx);
 glBegin(GL_Triangles);
 glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
 for i:=0 to num_Faces do
 for j:=0 to 2 do
  begin
   glColor4f(4,4,4,4);
   gltexcoord2fv(@TexV[Tex[i][j]]);
   glNormal3fv(@Normal[Face[i][j]]);
   glvertex3fv(@Render_Vertex[Face[i][j]]);
  end;
 glEnd;
end;

procedure TMesh.Test(name:string);  {test}
Var
 i,j:integer;
 z:integer;
 R:File of Char;
 S:string;
 h:single;
 a:char;
begin
 AssignFile(R,name);
 Rewrite(R);
 for i:=0 to num_Vertex-1 do
  for j:=0 to 2 do
   begin
    h:=Vertex[0][i][j];
    s:=FloatToStr(h);
    for z:=1 to length(S) do
     begin
      a:=s[z];
      write(R,a);
     end;
    a:=';';
    write(R,a);
    if j=2 then
     begin
      a:=#13;
      write(R,A);
     end;
   end;
 CloseFile(R);
end;

procedure TMesh.RenderRestore;
begin
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.RenderScale(F:Single);
Var i,j:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=multi(Render_Vertex[i],F);
end;

procedure TMesh.Scale(F:Single);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=multi(Vertex[j][i],F);
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.set_val(Var s:string;M,c:byte;var i:Cardinal; var j:Cardinal;var z:Cardinal; var L:Cardinal);
begin
 if (S<>'') then
  case m of
   1:case c of
      0:begin     {vertex nums}
         num_Vertex:=StrToInt(S);
         num_anim:=L;
         SetLength(Vertex,num_Anim+1);
         SetLength(Vertex[L],num_Vertex+1);
         SetLength(Normal,num_Vertex+1);
         i:=0;
         z:=0;
        end;
      1:begin Vertex[L][i][0]:=StrToFloat(S); end; {x}
      2:begin Vertex[L][i][1]:=StrToFloat(S); end; {y}
      3:begin Vertex[L][i][2]:=StrToFloat(S);
        if (i<num_Vertex) then i:=i+1;end; {z}
      4:begin Face[j][0]:=StrToInt(S)-1; end; {a}
      5:begin Face[j][1]:=StrToInt(S)-1; end; {b}
      6:begin Face[j][2]:=StrToInt(S)-1;
        if (j<num_Faces) then j:=j+1;end; {c}
      10:begin      {faces num}
          num_Faces:=StrToInt(S);
          SetLength(Face,num_Faces+1);
          j:=0;
         end;
     end;
   3:case c of
      0:begin      {textures num}
         num_Tex_Vertex:=StrToInt(S);
         SetLength(TexV,num_Tex_Vertex+1);
         SetLength(Tex,num_Faces+1);
         i:=0;j:=0;
         L:=L+1;
        end;
      1:begin texV[i][0]:=StrToFloat(S); end; {x}
      2:begin texV[i][1]:=StrToFloat(S);
        if (i<num_Tex_Vertex) then i:=i+1;end; {y}
      4:begin tex[j][0]:=StrToInt(S)-1; end; {a}
      5:begin tex[j][1]:=StrToInt(S)-1; end; {b}
      6:begin tex[j][2]:=StrToInt(S)-1;
        if (j<num_Faces) then j:=j+1;end;{c}
     end;
   4:case c of
      1:begin Normal[i][0]:=StrToFloat(S); end; {x}
      2:begin Normal[i][1]:=StrToFloat(S); end; {y}
      3:begin Normal[i][2]:=StrToFloat(S);
        if (i<num_Vertex) then i:=i+1;end; {z}
     end;
  end;
 S:='';
end;

procedure TMesh.LoadFromMMSFile(FileName:String);
Var
 F:File of Char;
 i,j,z,l:cardinal;{counters}
 S:string;
 a:char;
 Mode:byte;{trigger}    {0-none       1-Vertex num(vc)}
                        {2-Faces num  3-textures num  }
                        {4-normals                    }
 cnt:byte;              {0- num       1-x 2-y 3-z     }
                        {4-a 5-b 6-c                  }
begin
 mode:=0;
 cnt:=0;
 i:=0;
 j:=0;
 z:=0;
 l:=0;
 AssignFile(F,FileName);
 Reset(F);
 S:='';
 Repeat
  a:='q';
  read(F,a);
  Case a of
   'e','E','0','1'..'9','-':S:=S+a;{numbers (with minus and point for float)}
   '.',',':S:=S+',';
   'X','x':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=1;end;
   'Y','y':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=2;end;
   'Z','z':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=3;end; {float vertex and texture coords}
   'A','a':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=4;end;
   'B','b':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=5;end;
   'C','c':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=6;end; {int faces and textures for them}
   'V','v':begin set_val(s,Mode,cnt,i,j,z,l);mode:=1;cnt:=0;end;{prefix col vertex}
   'F','f':begin set_val(s,Mode,cnt,i,j,z,l);mode:=1;cnt:=10;end;{prefix col faces}
   'N','n':begin set_val(s,Mode,cnt,i,j,z,l);mode:=4;cnt:=0;end;{prefix normal}
   'T','t':begin set_val(s,Mode,cnt,i,j,z,l);mode:=3;cnt:=0;end;{prefix texture}
   'q','Q':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=0;mode:=3;end;{part of 'Tex' word}
   else begin set_val(s,Mode,cnt,i,j,z,l);cnt:=0;end;
  end;
 Until Eof(F);
 CloseFile(F);
 for i:=0 to num_Vertex do
  Normal[i]:=Normalize(Normal[i]);
 SetLength(Render_Vertex,num_vertex+1);
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.Add_Load(Name:String);
Var LoadMesh:TMesh;
i,z,q:Integer;
begin
 LoadMesh:=TMesh.Create;
 LoadMesh.LoadFromMMSFile(Name);
 SetLength(self.Normal,self.num_Vertex+LoadMesh.num_Vertex+2);
 For z:=0 to self.num_anim do
  begin
   SetLength(self.Vertex[z],self.num_Vertex+LoadMesh.num_Vertex+2);
   q:=z;
   for i:=0 to LoadMesh.num_Vertex do
    begin
     if q>LoadMesh.num_anim then q:=LoadMesh.num_anim;{esli animacii v dobavlyaemom meshe men`she}
     self.Vertex[z][i+self.num_Vertex]:=LoadMesh.Vertex[q][i];
    end;
  end;
 SetLength(self.Tex ,self.num_Faces+LoadMesh.num_Faces+2);
 SetLength(self.Face,self.num_Faces+LoadMesh.num_Faces+2);
 For i:=0 to LoadMesh.num_Faces do
  begin
   Face[i+self.num_Faces][0]:=LoadMesh.Face[i][0]+self.num_Vertex;
   Face[i+self.num_Faces][1]:=LoadMesh.Face[i][1]+self.num_Vertex;
   Face[i+self.num_Faces][2]:=LoadMesh.Face[i][2]+self.num_Vertex;
   Tex[i+self.num_Faces][0]:=LoadMesh.Tex[i][0]+self.num_Tex_Vertex;
   Tex[i+self.num_Faces][1]:=LoadMesh.Tex[i][1]+self.num_Tex_Vertex;
   Tex[i+self.num_Faces][2]:=LoadMesh.Tex[i][2]+self.num_Tex_Vertex;
  end;
 SetLength(TexV,num_Tex_Vertex+LoadMesh.num_Tex_Vertex+2);
 For i:=0 to LoadMesh.num_Tex_Vertex do
  begin
   TexV[i+self.num_Tex_Vertex]:=LoadMesh.TexV[i];
  end;
 num_Vertex:=num_Vertex+LoadMesh.num_Vertex+1;
 num_Tex_Vertex:=num_Tex_Vertex+LoadMesh.num_Tex_Vertex+1;
 num_Faces:=num_Faces+LoadMesh.num_Faces+1;
 Render_Vertex:=copy(Vertex[0]);
{}
end;

procedure TMesh.SaveMMSFile(name:string);
Var
 F:File of Char;
 i,j,z,l:cardinal;{counters}
 S:string;
 a:char;
 procedure Save_str(str:string);
 var q:byte;
  begin
   for q:=1 to Length(str) do
    begin
     a:=str[q];
     Write(F,a);
    end;
  end;
begin
 AssignFile(F,Name);
 Rewrite(F);
 for j:=0 to num_anim-1 do
 begin
 Save_str(' V');
 Save_str(intToStr(num_Vertex));
 Save_str(' F');
 Save_str(intToStr(num_Faces));
 Save_str(#13);
  for i:=0 to num_Vertex do
  begin
   Save_str('X'+floatToStrF(Vertex[j][i][0],ffGeneral,7,2));
   Save_str('Y'+floatToStrF(Vertex[j][i][1],ffGeneral,7,2));
   Save_str('Z'+floatToStrF(Vertex[j][i][2],ffGeneral,7,2));
   Save_str(#13);
  end;
 Save_str(#13);
 Save_str(' tq'+intToStr(num_tex_vertex));
 end;
 j:=num_anim;
 begin
 Save_str(' V');
 Save_str(intToStr(num_Vertex));
 Save_str(' F');
 Save_str(intToStr(num_Faces));
 Save_str(#13);
  for i:=0 to num_Vertex do
  begin
   Save_str('X'+floatToStrF(Vertex[j][i][0],ffGeneral,7,2));
   Save_str('Y'+floatToStrF(Vertex[j][i][1],ffGeneral,7,2));
   Save_str('Z'+floatToStrF(Vertex[j][i][2],ffGeneral,7,2));
   Save_str(#13);
  end;
 Save_str(#13);
 end;
 for i:=0 to num_Faces do
 begin
  Save_str(' a'+intToStr(Face[i][0]+1));
  Save_str(' b'+intToStr(Face[i][1]+1));
  Save_str(' c'+intToStr(Face[i][2]+1));
  Save_str(#13);
 end;
 Save_str(#13);
 Save_str(' tq'+intToStr(num_tex_vertex));
 Save_str(#13);
 for i:=0 to num_tex_vertex do
 begin
  Save_str('tx'+floatToStrF(TexV[i][0],ffGeneral,7,2));
  Save_str('ty'+floatToStrF(TexV[i][1],ffGeneral,7,2));
   Save_str(#13);
 end;
 Save_str(#13);
 for i:=0 to num_Faces do
 begin
  Save_str('ta'+intToStr(Tex[i][0]+1));
  Save_str('tb'+intToStr(Tex[i][1]+1));
  Save_str('tc'+intToStr(Tex[i][2]+1));
  Save_str(#13);
 end;
 CloseFile(F);
end;

end.
