unit Use_Geometry;

{
ver 0.003
3d / 2d procedure pack
by Mefistofel}

interface

uses OpenGl;

const pi=3.14159265358979;

type
 //TVector3f = array[0..2] of single;
 //TVector2f = array[0..1] of single;
 //TMatrix3f = array[0..2] of TVector3f; {with Opengl}
 {3d}
 TPoint = TVector3f;   {x,y,z}
 TMatrix = TMatrix3f;  {rotate/translate/scale matrix 3*3}
 {2d}
 TVect = TVector2f;

{ ========== Math ===============}
function Get_X_V(ang,val:single):single; {  sin}
function Get_Y_V(ang,val:single):single;{  cos}
function Get_R(S:single):single; {GRADUS in 360}
function Head_Rotate(SA,RA,Speed:single):single;
function Point_in_Rect(X,Y,AX,AY,BX,BY:Single):boolean;overload;{check point in box AA:BB}
{ ========== 3D Geometry ===============}
function point(X,Y,Z:single):TPoint;       {set point}
function ArcCos(const X: Single): Single;  {for calculation without Math}
function Get_S(X,Y,Z:single):single;overload;{get lendth of X,Y,Z Vector}
function Get_S(A:TPoint):single;overload; {get lendth of A(X,Y,Z) Vector}
function Get_S(A,B:TPoint):single;overload; {get lendth between A and B points}
function Normalize(A:TPoint):TPoint; {normalize}
function plus(A,B:TPoint):TPoint;overload; {Vector addition}
function minus(A,B:TPoint):TPoint;overload; {vector substraction}
function middle(A,B:TPoint):TPoint;overload;{middle point between A & B}
function multi(A:TPoint;F:single):TPoint;overload;{multiplication 3d vector on number}
function Between(A,B:TPoint;F:single):TPoint;{      (F  0  1)}
function Point_in_Rect(P:TPoint;A,B:TPoint):boolean;overload;{check point in box AAA:BBB}
{ ========== 2D Geometry ===============}
function Vector(X,Y:single):TVect; { }
function Get_S(A,B:TVect):single;overload;{  }
function Get_S(X1,Y1,X2,Y2:single):single;overload;{  }
function Get_A(A,B:TVect):single;overload;{angle of B for A}
function Get_A(A:TVect):single;overload; {angle of A Vector}
function Get_Vect(ang,spd:single):TVect;{  sin    }
function minus(A,B:TVect):TVect;overload; { }
function plus(A,B:TVect):TVect;overload;  { }
function middle(A,B:TVect):TVect;overload;  { }
function multi(A:TVect;F:single):TVect;overload;{multiplication 2d vector on number}
function Point_in_Rect(P:TVect;A,B:TVect):boolean;overload;{check point in box AAA:BBB}

implementation

{for all}
function ArcTan2(const Y, X: Extended): Extended;
asm
        FLD     Y
        FLD     X
        FPATAN
        FWAIT
end;

function ArcCos(const X: Single): Single;
begin
  Result := ArcTan2(Sqrt(1 - X * X), X);
end;

function Get_R(S:single):single; {GRADUS in 360}
begin
 Repeat
  If S<0 then S:=S+360;
  If S>=360 then S:=S-360;
 Until (S>=0) and (S<360);
 Get_R:=S;
end;

function Get_X_V(ang,val:single):single; {  sin}
begin
 Get_X_V:=cos(ang/180*pi)*val;
end;

function Get_Y_V(ang,val:single):single;{  cos}
begin
 Get_Y_V:=sin(ang/180*pi)*val;
end;

{           }
{  }
function Head_Rotate(SA,RA,Speed:single):single;
var s:ShortInt;    {SA - Source Angle RA - Rezult Angle}
begin
 If (RA>350) or (SA>350) or (RA<10) or (SA<10) then
  begin   {     ,   0  359 -    }
   RA:=Get_R(RA+180);SA:=Get_R(SA+180);
  end;
 S:=Round(Speed);
 If (ABS(RA-SA)<Speed) then S:=Round(ABS(RA-SA));{     ,   -    }
 If (SA<RA) then   {   }
  If (RA-SA<=180) then  {    }
   S:=S else S:=-1*S
  else
  If (SA-RA<180) then
   S:=-1*S else S:=S;  
 Head_Rotate:=S;
end;

function Point_in_Rect(X,Y,AX,AY,BX,BY:Single):boolean;overload;
var Temp:Single;   {check point in box AA:BB}
begin
 if AX>BX then begin temp:=AX;AX:=BX;BX:=Temp; end;
 if AY>BY then begin temp:=AY;AY:=BY;BY:=Temp; end;
 if (X>=AX) and (X<=BX) and
    (Y>=AY) and (Y<=BY) then
    Point_in_Rect:=true else Point_in_Rect:=false;
end;

{-------------------   3d   ---------------------}

function point(X,Y,Z:single):TPoint;  {set x,y,z point}
begin
 point[0]:=X;
 point[1]:=Y;
 point[2]:=Z;
end;

function Get_S(X,Y,Z:single):single;overload;{get lendth of X,Y,Z Vector}
Var s:single;
begin
 S:=sqrt(X*X+Y*Y+Z*Z);
 If S=0 then S:=0.0000001;  {    0}
 Get_S:=S;
end;

function Get_S(A:TPoint):single;overload; {get lendth of A(X,Y,Z) Vector}
Var s:single;
begin
 S:=sqrt(A[0]*A[0]+A[1]*A[1]+A[2]*A[2]);
 If S=0 then S:=0.0000001;  {    0}
 Get_S:=S;
end;

function Get_S(A,B:TPoint):single;overload; {get lendth between A and B points}
Var s:single;
begin
 A[0]:=B[0]-A[0];A[1]:=B[1]-A[1];A[2]:=B[2]-A[2];
 S:=sqrt(A[0]*A[0]+A[1]*A[1]+A[2]*A[2]);
 If S=0 then S:=0.0000001;  {    0}
 Get_S:=S;
end;

function Normalize(A:TPoint):TPoint; {normalize}
Var s:Single;
begin
 s:=A[0]+A[1]+A[2];
 Normalize[0]:=A[0]/S;
 Normalize[1]:=A[1]/S;
 Normalize[2]:=A[2]/S;    {X^2+Y^2+Z^2=1}
end;

function plus(A,B:TPoint):TPoint; {Vector addition}
begin
 plus[0]:=A[0]+B[0];
 plus[1]:=A[1]+B[1];
 plus[2]:=A[2]+B[2];
end;

function minus(A,B:TPoint):TPoint; {vector substraction}
begin
 minus[0]:=A[0]-B[0];
 minus[1]:=A[1]-B[1];
 minus[2]:=A[2]-B[2];
end;

function middle(A,B:TPoint):TPoint;{middle point between A & B}
begin
 middle[0]:=(A[0]+B[0])*0.5;
 middle[1]:=(A[1]+B[1])*0.5;
 middle[2]:=(A[2]+B[2])*0.5;
end;

function multi(A:TPoint;F:single):TPoint;overload;
begin
 multi[0]:=A[0]*F;
 multi[1]:=A[1]*F;
 multi[2]:=A[2]*F;
end;

function Between(A,B:TPoint;F:single):TPoint;
begin
 Between[0]:=A[0]+(B[0]-A[0])*F;
 Between[1]:=A[1]+(B[1]-A[1])*F;
 Between[2]:=A[2]+(B[2]-A[2])*F;
end;

function Point_in_Rect(P:TPoint;A,B:TPoint):boolean;overload;
var Temp:Single;
begin
 if A[0]>B[0] then begin temp:=A[0];A[0]:=B[0];B[0]:=Temp; end;
 if A[1]>B[1] then begin temp:=A[1];A[1]:=B[1];B[1]:=Temp; end;
 if A[2]>B[2] then begin temp:=A[2];A[2]:=B[2];B[2]:=Temp; end;
 if (P[0]>=A[0]) and (P[0]<=B[0]) and
    (P[1]>=A[1]) and (P[1]<=B[1]) and
    (P[2]>=A[2]) and (P[2]<=B[2]) then
    Point_in_Rect:=true else Point_in_Rect:=false;
end;

{----------------- 2d -------------------}

function Vector(X,Y:single):TVect; { }
begin
 Vector[0]:=X;
 Vector[1]:=Y;
end;

function Get_S(A,B:TVect):single;overload;{  }
var S:Single;
begin
 S:=sqrt((B[0]-A[0])*(B[0]-A[0])+(B[1]-A[1])*(B[1]-A[1]));
 If S=0 then S:=0.0000001;  {    0}
 Get_S:=S;
end;

function Get_S(X1,Y1,X2,Y2:single):single;overload;{  }
var S:Single;
begin
 S:=sqrt((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1));
 If S=0 then S:=0.0000001;  {    0}
 Get_S:=S;
end;

function Get_A(A,B:TVect):single;overload;  {angle of B point for A}
Var S,C:single;
begin
 C:=(B[0]-A[0])/Get_S(A,B);  {  }
 If C>1 then C:=1;            {   arcsin}
 If C<-1 then C:=-1;
 S:=(arccos(C))*180/pi;        {  }
 If (B[1]-A[1])>0 then S:=Get_R(360-S); { ,  -   :)   }
 S:=Get_R(-S);
 Get_A:=S;
end;

function Get_A(A:TVect):single;overload;  {  }
Var S,C:single;B:TVect;
begin
 B[0]:=0;
 B[1]:=0;
 C:=(A[0]-B[0])/Get_S(A,B); {  }
 If C>1 then C:=1;            {  }
 If C<-1 then C:=-1;
 S:=(arccos(C))*180/pi;        {  }
 If (A[1]-B[1])>0 then S:=Get_R(360-S); { ,  -   :)   }
 S:=Get_R(-S);
 Get_A:=S;
end;

function Get_Vect(ang,spd:single):TVect;{  sin    }
begin
 Get_Vect[0]:=cos(ang/180*pi)*spd;
 Get_Vect[1]:=sin(ang/180*pi)*spd;
end;

function minus(A,B:TVect):TVect;overload; { }
begin
 minus[0]:=A[0]-B[0];
 minus[1]:=A[1]-B[1];
end;

function plus(A,B:TVect):TVect;overload;  { }
begin
 plus[0]:=A[0]+B[0];
 plus[1]:=A[1]+B[1];
end;

function middle(A,B:TVect):TVect;overload;  { }
begin
 middle[0]:=(A[0]+B[0])/2;
 middle[1]:=(A[1]+B[1])/2;
end;

function multi(A:TVect;F:single):TVect;overload; {  }
begin
 multi[0]:=A[0]*F;
 multi[1]:=A[1]*F;
end;

function Point_in_Rect(P:TVect;A,B:TVect):boolean;overload;
var Temp:Single;{check point in 2d box}
begin
 if A[0]>B[0] then begin temp:=A[0];A[0]:=B[0];B[0]:=Temp; end;
 if A[1]>B[1] then begin temp:=A[1];A[1]:=B[1];B[1]:=Temp; end;
 if (P[0]>=A[0]) and (P[0]<=B[0]) and
    (P[1]>=A[1]) and (P[1]<=B[1]) then
    Point_in_Rect:=true else Point_in_Rect:=false;
end;

end.
