unit Use_jpg;

interface

uses Windows, Messages, OpenGl, JPeg, Graphics;

type
  PRGB = record        {      }
   r,g,b:byte;
  end;
  TSline = array[0..1] of PRGB;   { }

function LoadJPGATexture(FileName: String;FileNameAlpha:String; var TexIndex: Cardinal):pointer;
function LoadJPGTexture(FileName: String; var TexIndex: Cardinal):pointer;

implementation
    
function GenTexture(Var pData: Pointer;Width: LongWord;Height: LongWord; var Texture: GLuint): Boolean;
begin
  if (Assigned(pData)) then
    Result := True
  else
  begin
    Result := False;
    exit;
  end;
  glGenTextures(1, @Texture);
  glBindTexture(GL_TEXTURE_2D, Texture);
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);  {Texture blends with object background}
//  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);  {Texture does NOT blend with object background}
//  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);  {Texture does NOT blend with object background}
//  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);  {Texture does NOT blend with object background}
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); { only first two can be used }
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST); { all of the above can be used }
// gluBuild2DMipmaps(GL_TEXTURE_2D, 3, Width, Height, GL_RGB, GL_UNSIGNED_BYTE, pData);
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, Width, Height, 0, GL_RGBA, GL_UNSIGNED_BYTE, pData);  // Use when not wanting mipmaps to be built by openGL
end;

function LoadJPGTexture(FileName: String; var TexIndex: Cardinal):pointer;
Var
  i,j,BW,BH:integer;        { }
  BM:TBitMap;         {  }
  JI:TJpegImage;      {    }
  P:^TSline;          {    -    ,   RGB}
  TA:array of byte;
  S:Pointer;
begin
 BM:=TBitMap.Create;
 JI:=TJpegImage.Create;
 JI.LoadFromFile(FileName);
 BM.Assign(JI);
 JI.Destroy;
 SetLength(TA,BM.Width*BM.Height*4);
 BW:=BM.Width;     { (     )}
 BH:=BM.Height;
 For j:=0 to BH-1 do {  }
 begin
  P:=BM.ScanLine[j]; {     -  }
  For i:=0 to BW-1 do {  }
  begin
   TA[i*4+(BH-1-j)*BW*4+0]:=p[i].b;
   TA[i*4+(BH-1-j)*BW*4+1]:=p[i].g;
   TA[i*4+(BH-1-j)*BW*4+2]:=p[i].r;
   TA[i*4+(BH-1-j)*BW*4+3]:=255;
  end;
 end;
 S:=TA;
 GenTexture(S,BW,BH,TexIndex);
 //gen_Sphere_texture:=TA;      {      }
 BM:=nil;
 BM.Free;              { }
end;

function LoadJPGATexture(FileName: String;FileNameAlpha:String; var TexIndex: Cardinal):pointer;
Var
  i,j,BW,BH:integer;        { }
  BM:TBitMap;         {  }
  BA:TBitMap;         {  }
  JI:TJpegImage;      {    }
  P,Q:^TSline;          {    -    ,   RGB}
  TA:array of byte;
  S:Pointer;
begin
 BM:=TBitMap.Create;
 BA:=TBitMap.Create;
 JI:=TJpegImage.Create;
 JI.LoadFromFile(FileName);
 BM.Assign(JI);
 JI.LoadFromFile(FileNameAlpha);
 BA.Assign(JI);
 JI.Destroy;
 SetLength(TA,BM.Width*BM.Height*4);
 BW:=BM.Width;     { (     )}
 BH:=BM.Height;
 For j:=0 to BH-1 do {  }
 begin
  P:=BM.ScanLine[j]; {     -  }
  Q:=BA.ScanLine[j];
  For i:=0 to BW-1 do {  }
  begin
   TA[i*4+(BH-1-j)*BW*4+0]:=p[i].b;
   TA[i*4+(BH-1-j)*BW*4+1]:=p[i].g;
   TA[i*4+(BH-1-j)*BW*4+2]:=p[i].r;
   TA[i*4+(BH-1-j)*BW*4+3]:=Q[i].r;
  end;
 end;
 S:=TA;
 GenTexture(S,BW,BH,TexIndex);
 //gen_Sphere_texture:=TA;      {      }
 BM:=nil;
 BM.Free;              { }
 BA:=nil;
 BA.Free;              { }
end;

end.
