#include <windows.h>
#include <iostream>

#include <hge.h>
#include <hgeSprite.h>
#include "runner.h"

#include <hgeresource.h>

runner::runner(float _runnerPositionX,float _runnerPositionY,HTEXTURE _texture,int _runner_number)
{
	runnerPositionX=_runnerPositionX;
	runnerPositionY=_runnerPositionY;
	RectTile = new hgeRect(runnerPositionX+6,runnerPositionY+6,runnerPositionX+26,runnerPositionY+26);
	runner_number=_runner_number;
    keys=0;
	lifes=0;
	timer_immortality=0;
	immortality=false;
	removed=false;
	//   
    xSprite=2+34*(runner_number%4); 
    ySprite=2+34*(runner_number/4);
    ladder=false;
	direction=0; //right by default
	cord=false;
	
	
       for(int i=0;i<6;i++)
	   {
	    anim[i]= new hgeAnimation(_texture,16,1,0,32*i,32,32);
		anim[i]->Play();
	   }
	//sprite= new hgeSprite(_texture,xSprite,ySprite,32,32);	
	//sprite=_anim; 
	
	intersection=false;
};

void runner::drawRunner(int n_anim)
{
	 anim[n_anim]->Render(runnerPositionX,runnerPositionY);
};

void runner::moveRunner(float _dx,float _dy)
{
 runnerPositionX+=_dx;
 runnerPositionY+=_dy;
 RectTile->Set(runnerPositionX+6,runnerPositionY+6,runnerPositionX+26,runnerPositionY+26);
 pointX=runnerPositionX+16;
 pointY=runnerPositionY+16;
}

bool runner::checkIntersection(tile * _tile,int type_of_action)
{
	return RectTile->Intersect(_tile->RectTile);
}

bool runner::checkIntersectionEnemy(enemy * _enemy,int type_of_action)
{
	return RectTile->Intersect(_enemy->RectTile);
}



bool runner::checkPointIntersection(hgeRect * Rect)
{
	if(direction==0)
	  return Rect->TestPoint(runnerPositionX+48,runnerPositionY+48);
	if(direction==1)
     return Rect->TestPoint(runnerPositionX-16,runnerPositionY+48);
	if(direction==2)
     return Rect->TestPoint(runnerPositionX+16,runnerPositionY-16);
	if(direction==3)
     return Rect->TestPoint(runnerPositionX+16,runnerPositionY+48);
	else
	 return false;
}
	

bool runner::runnerDown(float dv,int speed)
{
    runnerPositionY+=dv*speed;
	return true;
}
bool runner::setRunnerPosition(float _x,float _y)
{
 runnerPositionX=_x;
 runnerPositionY=_y;
 RectTile->Set(runnerPositionX,runnerPositionY,runnerPositionX+32,runnerPositionY+32);
 pointX=runnerPositionX+16;
 pointY=runnerPositionY+16;
 return true;
}