unit BR_map;
// 
interface
uses
  Omega, BR_materials, BR_game;

type
  TkT = ( none, clip, clip2, left, top);

  TKl = record
    B,  F,  O,  S,  L,          // , , , ,  
    Ba, Fa, Oa, Sa, La,         // ...
    ScH, ScB            : byte; // 
    T : TkT;                    // , , ,  
  end;

  Tpers = record
    X, Y : integer;
    T : byte;
  end;

  Tmap = record
    Kl : array [0..32, 0..12] of TKl;
    Hero : TPers;
  end;

  TmapKl = record
    Alpha, St, T    : byte;
  end;

const
  Ed_X = 32;  {1/4 * Ed_RX}
  Ed_Y = 64; {1/8 * Ed_RX}

  Ed_RX = 32-16;
  Ed_RY = 64-17;

var
  Map : Tmap;
  MapKl : array [0..32, 0..16] of TmapKl;

procedure Draw;
procedure Work;
procedure Clear;
procedure Open(FN : string);
procedure Save(FN : string);

implementation

procedure Draw;
var
 iX, iY, AA_o : byte;
 Flag : integer;



procedure DrawAT(A, I, I2: byte; tX, tY : integer);

  function GetKLAlpha : byte;
  begin
    if (A=A_b) then
     result:=255
    else
    if (A=A_f) and (iY<12) then
     result:=MapKl[iX, iY+1].Alpha
    else
     result:=MapKl[iX, iY].Alpha;
  end;

begin
  if I>0 then
    begin
      with TData.CA[A][I] do
      if T=0 then
      SSprite_Draw(TA[A][I], iX*Ed_X+tX+pX, iY*Ed_Y+tY+pY, W, H, GetKLAlpha)
      else
      ASprite_Draw(TA[A][I], iX*Ed_X+tX+pX, iY*Ed_Y+tY+pY, W, H, I2, GetKLAlpha);
    end;
end;

begin
  for iX:=32 downto 0 do
  for iY:=16 downto 0 do
    begin
   { A_b = 1;  //    
     A_l = 2;  //  
     A_f = 3;  // 
     A_s = 4;  //  
     A_o = 5;  //        }
      DrawAT(A_b, Map.Kl[iX, iY].B,  Map.Kl[iX, iY].Ba, -16,   -17 );
      DrawAT(A_f, Map.Kl[iX, iY].F,  Map.Kl[iX, iY].Fa, -16, Ed_RY );
      case Map.Kl[iX, iY].T of
        top  : AA_o:= 6;
        left : AA_o:= 7;
         else  AA_o:= 5;
      end;
      DrawAT(AA_o, Map.Kl[iX, iY].O, Map.Kl[iX, iY].Oa,  -8,    -8 );
      DrawAT(A_l,  Map.Kl[iX, iY].L, Map.Kl[iX, iY].La, -16,   -17 );
    end;

  if HeroP2.Left then Flag:=FX_DEFAULT or FX_FLIPX
  else Flag:=1;

  if Map.Hero.T>0 then
    Omega.ASprite_Draw(THero[HeroP2.Animation], Map.Hero.X, Map.Hero.Y, 64, 64, round(HeroP2.AnimationN), 255, 0, Flag);

  for iX:=32 downto 0 do
  for iY:=16 downto 0 do
    begin
      DrawAT(A_s, Map.Kl[iX, iY].S,  Map.Kl[iX, iY].Sa, 0, -1);
    end;

end;

procedure Work;
var
  iX, iY : byte;
begin
  for iX:=32 downto 0 do
  for iY:=16 downto 0 do
      if MapKL[iX, iY].ST>0 then
      case MapKL[iX, iY].ST of
        1 : if MapKL[iX, iY].Alpha>70 then dec(MapKL[iX, iY].Alpha) else
              begin
                MapKL[iX, iY].T:=255;
                MapKL[iX, iY].ST:=2;
              end;
        2 : if MapKL[iX, iY].T>5 then dec(MapKL[iX, iY].T) else MapKL[iX, iY].ST:=3;
        3 : if MapKL[iX, iY].Alpha<255 then inc(MapKL[iX, iY].Alpha) else MapKL[iX, iY].ST:=0;
      end;

end;

procedure Clear;
var
  iX, iY : byte;
begin
  for iX:=0 to 32 do
  for iY:=0 to 16 do
    begin
      Map.Kl[iX, iY].B:= 0;
      Map.Kl[iX, iY].Ba:=0;
      Map.Kl[iX, iY].F:= 0;
      Map.Kl[iX, iY].Fa:=0;
      Map.Kl[iX, iY].O:= 0;
      Map.Kl[iX, iY].Oa:=0;
      Map.Kl[iX, iY].S:= 0;
      Map.Kl[iX, iY].Sa:=0;
      Map.Kl[iX, iY].L:= 0;
      Map.Kl[iX, iY].La:=0;
      MapKl[iX, iY].Alpha:=255;
      MapKl[iX, iY].St:=0;
    end;
  Map.Hero.T:=0;
end;

procedure Open(FN : string);
var
  F : file;
begin
  Clear;
  assignfile(F, FN);
  reset(F, 1);
  BlockRead(F, Map, SizeOf(TMap));
  closefile(F);
end;

procedure Save(FN : string);
var
  F : file;
begin
  assignfile(F, FN);
  rewrite(F, 1);
  BlockWrite(F, Map, SizeOf(TMap));
  closefile(F);
end;

end.
